<html>
<head>
<title>SmartSSD Wear Gauge Report</title>
<style type="text/css">
body
{
   font-family:Arial,sans-serif;
   margin:0px;
   padding:0px;
   font-size:11px;
}

table,input,select
{
   font-family:Arial,sans-serif;
   font-size:11px;
}

h3.subTitle 
{
   background-color:#666;
   font-weight:bold;
   color:#fff;
   padding:2px 5px 2px 8px;
   margin:0px;
   font-size:100%;
   text-align:left;
}

div.subTitleBottomEdge 
{
   height:3px;
   overflow:hidden;
   background:#484848;
}	
	
/* links */
a:link, a:visited, a:active, a:hover 
{
   color: #003399;
   text-decoration:none;
}
a:hover {
   color: #003399;
   text-decoration:underline;
}

/* buttons */
button.hpButtonVerySmall
{
   border-style:none;
   padding:0px 4px;
   height:13px;
   font-size:9px;
   color: #fff;
   width: 27px;
}
button.hpButtonVerySmall
{
   position:relative;
   left:-1px;
   top:-1px;   
/* background color a part of the theme css */
   color: #fff; 
   font-weight:bold;
   text-decoration: none;   
   font-family: Arial,sans-serif;
   text-align:center;
   cursor:pointer;
   cursor:hand;
}

div.bWrapperUp,
div.bWrapperOver,
div.bWrapperDown,
div.bWrapperDisabled {
   float:right;
   direction:ltr;
   margin-left:8px;
   margin-bottom:8px;
}
div.buttonSet
{
   float:right;
   margin-bottom:10px;
   padding-left:13px;
}

/* buttonsAreLeftAligned is a modifier class, modifying buttonSet */
div.buttonsAreLeftAligned, div.buttonsAreLeftAligned div.bWrapperUp,div.buttonsAreLeftAligned div.bWrapperOver,div.buttonsAreLeftAligned div.bWrapperDown,div.buttonsAreLeftAligned div.bWrapperDisabled {
   float:left;
   margin-left:0px;
   margin-right:8px;
}

/* this position relative css is what turns the three divs into the 3px slant effect */
div.bWrapperUp div,div.bWrapperOver div,div.bWrapperDown div,div.bWrapperDisabled div{
   position:relative;
   left:-1px;
   top:-1px;
}

button.hpButtonVerySmall
{
   background-color: #7591AC;
}

/* these are the right and bottom edge colors for the various states */
div.bWrapperUp,
div.bWrapperUp div{
   background-color:#3F658C;
}

/* report */

#SmartSSDWearGaugeReport
{
   position:absolute;
}

#DIV_STATUS_ID
{
   position:absolute;
   height:117px;
   background:#ccc;
}

#DIV_VIEW_ID
{
   position:absolute;
   height:50px;
   background:#ccc;
}

#DIV_TREE_ID
{
   position:absolute;
   overflow:auto;
   border-left:3px solid #ccc;
   border-right:3px solid #ccc;
   border-bottom:3px solid #ccc;
   padding:5px;
}

#DIV_TREE_ID a
{
   outline: 0;
}

#DIV_INFO_ID
{
   position:absolute;
   border:3px solid #ccc;
   padding:3px 10px 10px 10px;
   overflow:auto;
}

.SSDTreeIcon
{
   display:inline;
   margin-right:8px;
}

.SSDTreeOverlayIcons
{
   display:inline;
}

.SSDOverlay
{
   display:inline;
   width:12px;
   margin-left:-16px;
   margin-top:10px;
}

.SSDTreeGroup
{
   white-space:nowrap;
   cursor:pointer;
   padding:3px 5px;
}

.SSDInfoHeader, .SSDInfoHeaderViewer
{
   width:100%;
   margin-bottom:10px;
   border-collapse:collapse;
}

.SSDInfoHeaderViewer
{
   margin-top:7px;
}

.SSDInfoHeaderTitle
{
   font-weight:bold;
   font-size:16px;
   border-collapse:collapse;
}

.SSDTreeElement
{
   white-space:nowrap;
   cursor:pointer;
   padding:3px 5px;
   margin-left:16px;
}

.SSDTreeImage
{
   display:inline;
   margin-right:5px;
}

.SSDTreeToggle
{
   display:inline;
   margin-right:4px;
}

.SSDTreeToggleViewer
{
   float:left;
   margin-right:4px;
   width:7px;
   padding-top:2px;
   font-weight:bold;
}

.SSDBarLG
{
   display:inline;
   margin-right:5px;
   height:30px;
   padding-bottom:2px;
}

.SSDBarSM
{
   display:inline;
   margin-right:5px;
   height:20px;
}

.SSDLabel, .SSDLabelSelected, .SSDLabelBlurred
{
   padding:1px 3px;
   line-height:20px;
   color:#000;
}

.SSDGroupLabel
{
   margin-left:0;
   padding:1px 3px 1px 0;
   line-height:20px;
   color:#000;
   font-weight:bold;
}

.SSDLabelSelected
{
   background-color:#5391CD;
   color:#fff;
}

.SSDLabelBlurred
{
   background-color:#CCC;
}

.moreInfoTable 
{
	width:100%;
   border-collapse:collapse;
   font-size:11px;
}

.moreInfoTable td  
{
   padding:2px 5px 1px 5px;
   border:1px solid #ccc;
   vertical-align:top;
}

.moreInfoLabel 
{
    background-color:#968F89;
    font-weight:bold;
    text-align:left;
    vertical-align:top;
    padding:3px 5px 2px 5px;
    color:#fff;
    width:294px;
}

.moreInfoValue 
{
	color:black;
	background-color: #EEEEEE; 
	width: auto;
	text-align:left; 
	padding: 2px 4px 2px;
}

/* alternate table row colors */
.moreInfoAltRow {
    background-color:#F5F5F5;
}

.moreInfoHeader 
{
    background-color:#716B66;
    font-weight:bold;
    text-align:left;
    vertical-align:top;
    padding:3px 5px 2px 5px;
    color:#fff;
}

.clear
{
   clear:both;
}

.aLink
{
   color:#003366;
   text-decoration:none;
}

.aLink:hover
{
   text-decoration:underline;
}

.hiddenLink
{
   position:absolute;
   top:0px;
   left:0px;
   outline:0;
}

.divPadding
{
   padding:10px 0 0 0;
}

.SSDViewLabel
{
}

.SSDView
{
   position:absolute;
   width:100%;
}

.SSDViewSettings, .SSDViewSettingsIE
{
   float:right;
   padding-top:5px;
}

.SSDViewSettingsIE
{
   padding-top:4px;
}

.SSDView select
{
   margin:0 5px;
}

.reportInfoLeft
{
   text-align:left;
   padding:0 0 2px 5px;
}

.reportInfoRight
{
   text-align:right;
   padding:0 5px 0 0;
}

.SSDDivBar
{
   float:left;
}

.SSDDivBarIE
{
   display:inline;
}

.TaskOverlay {margin-left:-24px; margin-bottom:-36px;z-index:-4;}
.TaskOverlayLeft {margin-left:-72px; margin-bottom:-36px;}
.TaskOverlayTL {margin-left:-36px; margin-bottom:36px;}

/* Application Masthead */

#ApplicationHeader {
   color:#fff;
}
table.applicationMastheadSmall,table.applicationMastheadSmall td {
   background-color:#003366;
   color:#fff;
   vertical-align:top;
}
td.mastheadTitle {
   padding-top:8px;
}
td.mastheadTitle h1{
   padding:0px;
   margin:0px;
   padding:0 16px;
   color:#fff;
   white-space:nowrap;
   font-weight:normal;
   font-size:180%;
}
td.mastheadLinks {   
   padding:5px 16px;
   white-space:nowrap;
   border-left:7px solid #fff;
}
</style>

<script type="text/javascript">
   var g_isMoz = false;
   if (window.navigator != null && window.navigator.userAgent.indexOf("ecko") != -1)
   {
      g_isMoz = true;
   }
   // g_isViewer is the switch to control where the program is called from.
   // It is set in HandleOnLoad() when the page is loaded.
   // If g_isViewer == false, it is called from ADU. Images/icons will be displayed.
   // If g_isViewer == true, it is called from viewer to display json files. Images/icons will not be displayed.
   var g_isViewer;
   var g_sTreeToggleClass = "SSDTreeToggle";
   var g_sSSDInfoHeaderClass = "SSDInfoHeader";
   var g_sTreeExpandBtn;
   var g_sTreeContractBtn;
   var g_sJSONData = "";
   var g_oSmartSSDWearGaugeReport = null;
   var g_oOverallStatus = null;
   var g_sBarClass = "SSDDivBar";
   if (!g_isMoz)
   {
      g_sBarClass += "IE";
   }
   var SSD_GROUP_BY_CONTROLLER = 0;
   var SSD_GROUP_BY_STATUS = 1;
   var SSD_SORT_BY_WEAR = 2;
   var SSD_SORT_BY_DAYS_LEFT = 3;
   var SSD_SORT_BY_DRIVE_TYPE = 4;
   var SSD_FILTER_BY_ALL = 5;
   var SSD_FILTER_BY_HIDE_OK = 6;
   var SSD_FILTER_BY_SMARTSSD = 7;

   function ajaxRequest()
   {
      var activexmodes = ["Msxml2.XMLHTTP", "Microsoft.XMLHTTP"];  //activeX versions to check for in IE
      if (window.ActiveXObject)
      { //Test for support for ActiveXObject in IE first (as XMLHttpRequest in IE7 is broken)
         for (var i = 0; i < activexmodes.length; i++)
         {
            try
            {
               return new ActiveXObject(activexmodes[i]);
            }
            catch (e)
            {
               //suppress error
            }
         }
      }
      else if (window.XMLHttpRequest) // if Mozilla, Safari etc
      {
         var req = new XMLHttpRequest();
         req.overrideMimeType("application/json");
         return req;
      }
      else
      {
         return false;
      }
   }

   // Gets element by ID.
   function GE(eid)
   {
      return document.getElementById(eid);
   }

   // Prevents selection on given element.
   // elem - element to disable selection on
   // bKeepCursor - true if the cursor should not be modified
   function disableSelection(elem, bKeepCursor)
   {
      if (elem)
      {
         elem.onselectstart = function() { return false; };
         elem.unselectable = "on";
         elem.style.MozUserSelect = "none";
         if (!bKeepCursor)
         {
            elem.style.cursor = "default";
         }
      }
   }

   function getAttribute(oSmart, sID)
   {
      if (typeof (oSmart) != "undefined")
      {
         for (var i = 0; i < oSmart.length; ++i)
         {
            if (typeof (oSmart[i].id) != "undefined")
            {
               if (oSmart[i].id == sID)
               {
                  return oSmart[i].value;
               }
            }
         }
      }
   }

   // SmartSSD Wear Gauge Report Classes
   function CSmartSSDWearGaugeReport(sStatusID, sInfoID, sViewID, sTreeID)
   {
      var m_sStatusContainerID = sStatusID;
      var m_sStatusID = sStatusID + "_INFO";
      var m_sViewContainerID = sViewID;
      var m_sViewID = sViewID + "_BUTTONS";
      var m_sTreeID = sTreeID;
      var m_sLinkID = CSSDTree.getUID();
      var m_sInfoID = sInfoID;
      var m_sInfoTableID = "DIAGNOSTICS_SSD_INFO_TABLE";
      this.m_oSSDContainer = new CSSDContainer();
      var m_oStatus = new CSSDStatus(this, m_sStatusID);
      var m_oView = new CSSDView(this, m_sViewID);
      var m_oTree = new CSSDTree(this, m_sTreeID, m_sLinkID);
      var m_isAlt = 0; // alternate the rows light/dark/light/dark, etc.
      var m_sAltClass = " moreInfoAltRow";

      this.draw = function()
      {
         var s = '';

         // Draw banner only in viewer
         if (g_isViewer)
         {
            var oMPL = g_sJSONData.SmartSSDWearGaugeReport.MetaPropertyList;
            var sVersion = getAttribute(oMPL, "ACU Version");
            if (typeof (sVersion) == "undefined")
            {
               sVersion = getAttribute(oMPL, "ADU Version");
            }
            s += '<div id="ApplicationHeader" style="height:40px;">';
            s += '<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%" class="applicationMastheadSmall">';
            s += '<tr>';
            s += '<td class="mastheadTitle" width="80%"><h1>HP Array Diagnostics and SmartSSD Wear Gauge Utility</h1></td>';
            //s += '<td><div class="mastheadPhoto"><img id="APP_LOGO_ID" src="images/app_logo_4.jpg" height="40" width="215" alt="HP"/></div></td>';
            s += '<td class="mastheadLinks" width="20%" lang="en">';
            s += '<br/>Version: ' + sVersion + '</td>';
            s += '</tr>';
            s += '</table>';
            s += '</div>';
            GE("banner").innerHTML = s;
            s = '';
         }

         // Splitter Bar
         s += '<div id="SSD_SPLITTER_CONTAINER" style="position:absolute;width:100%;height:100%;z-index:3;">';
         s += '<div style="cursor:col-resize;position:absolute;width:7px;top:0px;left:' + CResizeCtrl.ssdMiddleLeftWidthUnitValuePrePxString + 'px;height:100%;z-index:4;" id="SSD_SPLITTER_BAR"></div>';

         // Status Container.
         s += '<div id="' + m_sStatusContainerID + '">';
         s += "<h3 class='subTitle'>Solid State Drives Overall Status</h3>";
         s += "<div class='subTitleBottomEdge'></div>";
         s += '<div id="' + m_sStatusID + '" class="SSDStatus"></div>';
         s += '</div>';

         // View Container.
         s += '<div id="' + m_sViewContainerID + '">';
         s += "<h3 class='subTitle'>Solid State Drives and Devices</h3>";
         s += '<div class="subTitleBottomEdge"></div>';
         s += '<div id="' + m_sViewID + '" class="SSDView"></div>';
         s += '</div>';

         // Tree.
         s += '<div id="' + m_sTreeID + '"></div>'; // tree
         s += '<a class="hiddenLink" href=# id="' + m_sLinkID + '"></a>';

         // Draw right information dialog.
         s += '<div id="' + m_sInfoID + '"></div>';

         // Close Splitter Bar
         s += '</div>';

         GE("SmartSSDWearGaugeReport").innerHTML = s;
         var nSplitterMargin = 0;
         new CSplitterBar("SSD_SPLITTER_CONTAINER", "SSD_SPLITTER_BAR", CResizeCtrl.setSplitterUnitWidthValue, nSplitterMargin, CResizeCtrl.minSplitterWidth, CResizeCtrl.minSplitterRightWidth);
         this.Update();
         this.DrawSummary();
      }

      this.Update = function()
      {
         CResizeCtrl.handleResize();
         m_oTree.Update();
         m_oStatus.draw();
         m_oView.draw();
      }

      this.collapseAllNodes = function()
      {
         m_oTree.collapseAllNodes();
      }

      this.expandAllNodes = function()
      {
         m_oTree.expandAllNodes();
      }

      this.updateGroupBy = function(sVal)
      {
         m_oTree.updateGroupBy(sVal);
      }

      this.updateSortBy = function(sVal)
      {
         m_oTree.updateSortBy(sVal);
      }

      this.updateFilterBy = function(sVal)
      {
         m_oTree.updateFilterBy(sVal);
      }

      this.selectElement = function(sID)
      {
         m_oTree.selectElementByID(sID);
      }

      // Displays the more info for a device to the right of the tree.
      this.DrawMoreInfo = function()
      {
         this.resetAlt();
         var s = "";
         var oSSD = m_oTree.getSelected();
         if (m_oTree && oSSD)
         {
            var oDev = oSSD.m_oDevice;
            var sTitle = oSSD.getTitle(false, false);
            var sSmartSSDLogFull = getAttribute(oDev.SmartSSDWearGauge, "Log Full");
            var bSmartSSDLogFull = typeof (sSmartSSDLogFull) != "undefined" && sSmartSSDLogFull == "TRUE";
            var bValidData = oSSD.isSmartSSDSupported() && !bSmartSSDLogFull;

            // Draw header.
            s += '<table class="' + g_sSSDInfoHeaderClass + '"><tr>'; ; //72px
            if (!g_isViewer)
            {
               s += '<td style="width:80px;">';
               s += getHeaderIconHTML(oSSD);
               s += '</td>';
            }
            s += '<td style="text-align:left;">';
            s += '<table class="SSDInfoHeaderTitle"><tr><td>';
            if (bValidData)
            {
               var nUtilization;
               var sUtilization = getAttribute(oDev.SmartSSDWearGauge, "Utilization");
               var nLifeLeft = oSSD.getUsageRemaining();
               var sDaysRemaining = oSSD.getDaysRemaining();
               var sSmartTrip = getAttribute(oDev.SmartSSDWearGauge, "SSD SMART Trip for Wearout");
               var bValidLifeLeft = typeof (sUtilization) != "undefined" && sUtilization >= 0 && sUtilization <= 100;
               if (bValidLifeLeft)
               {
                  nUtilization = parseFloat(sUtilization);
                  nLifeLeft = 100 - nUtilization;
                  var nBarLifeLeft;
                  if (nLifeLeft >= 5)
                  {
                     nBarLifeLeft = Math.floor(nLifeLeft);
                  }
                  else if (nLifeLeft < 5)
                  {
                     nBarLifeLeft = nLifeLeft.toFixed(2);
                  }
                  if (g_isViewer)
                  {
                     s += oSSD.getBar2(true);
                  }
                  else
                  {
                     s += oSSD.getBar(true);
                  }
                  s += '<span class="SSDLifeRemaining">(Usage Remaining: ' + nBarLifeLeft + '%)</span>';
                  s += '</td></tr><tr><td>';
               }
            }
            s += sTitle;
            s += '</td></tr></table>';
            s += '</td>';
            s += '<td style="text-align:right;">';
            s += '</td></tr></table>';
            s += '<div id="' + m_sInfoTableID + '">';

            // SmartSSD Status Table.
            s += this.StartTable();
            s += this.DisplayHeader("SmartSSD Status");

            // Display SSD Wear Status
            var sSSDWearStatus = oSSD.getStatusText();
            if (!oSSD.isSmartSSDSupported())
            {
               sSSDWearStatus = "Not Supported";
            }
            else if (bSmartSSDLogFull)
            {
               sSSDWearStatus = "The SmartSSD Wear Gauge log is full. Wear gauge parameters are not available.";
            }
            s += this.DisplayStringPair("SSD Wear Status", sSSDWearStatus);

            if (bValidData)
            {
               //s += this.DisplayAttr("Power Cycles"); // Smart Array Only
               s += this.DisplayAttr("Power On Hours");
               if (typeof (sDaysRemaining) != "undefined")
               {
                  s += this.DisplayStringPair("Estimated Life Remaining Based On Workload To Date", sDaysRemaining + " day(s)");
               }
               if (bValidLifeLeft)
               {
                  s += this.DisplayStringPair("Usage Remaining", nLifeLeft.toFixed(2) + "%");
                  s += this.DisplayStringPair("SSD Utilization", nUtilization.toFixed(2) + "%");
               }
            }
            s += this.EndTable();
            s += this.Break();

            // Physical Drive Table
            var sSSDType = oDev.deviceType;
            var oPhysicalDriv, sPhysicalDrive;
            var sSerialNumber, sFirmwareRevision;
            if (typeof (sSSDType) != "undefined")
            {
               if (sSSDType == "NonSmartArrayPhysicalDrive")
               {
                  oPhysicalDrive = oDev.PhysicalDriveInfo;
                  sPhysicalDrive = "PhysicalDriveInfo";
                  sSerialNumber = getAttribute(oPhysicalDrive, "Serial Number");
                  sFirmwareRevision = getAttribute(oPhysicalDrive, "Firmware Revision");
               }
               else
               {
                  oPhysicalDrive = oDev.PhysicalDriveStatus;
                  sPhysicalDrive = "PhysicalDriveStatus";
                  sSerialNumber = getAttribute(oPhysicalDrive, "Drive Serial Number");
                  sFirmwareRevision = getAttribute(oPhysicalDrive, "Drive Firmware Revision");
               }
               //printJaveObject(oPhysicalDriveInfo);

               s += this.StartTable();
               s += this.DisplayHeader("Physical Drive");
               // Display Status
               var sPhysicalStatus = oSSD.getPhysicalStatus();
               if (typeof (sPhysicalStatus) != "undefined")
               {
                  s += this.DisplayStringPair("Physical Drive Status", sPhysicalStatus);
               }
               s += this.DisplayAttr("Drive Type", sPhysicalDrive, "Drive Configuration Type"); // Not find in JSon
               var sSize = oSSD.getDriveSize();
               if (typeof (sSize) != "undefined")
               {
                  s += this.DisplayStringPair("Size", sSize);
               }
               var sSSDInterface = oSSD.getInterface();
               if (typeof (sSSDInterface) != "undefined")
               {
                  s += this.DisplayStringPair("Drive Type", sSSDInterface);
               }
               s += this.DisplayAttr("Drive Model", sPhysicalDrive, "Model");
               //s += this.DisplayAttr(ATTR_NAME_PRODUCT_ID); // Not find in JSon
               if (typeof (sSerialNumber) != "undefined")
               {
                  s += this.DisplayStringPair("Serial Number", sSerialNumber);
               }
               if (typeof (sFirmwareRevision) != "undefined")
               {
                  s += this.DisplayStringPair("Firmware Revision", sFirmwareRevision);
               }
               s += this.DisplayTemp("Current Temperature", oPhysicalDrive);
               s += this.DisplayTemp("Maximum Temperature", oPhysicalDrive);
               //s += this.DisplayAttr("Rotational Speed", oPhysicalDrive); // Not find in JSon
               s += this.DisplayAttr("PHY Count", sPhysicalDrive);
               //s += this.DisplayAttr(ATTR_NAME_TRANSFER_MODE); // Not find in JSon
               //s += this.DisplayAttr(ATTR_NAME_TRANSFER_RATE); // Not find in JSon
               //s += this.DisplayAttr("Negotiated Link Rate", sPhysicalDrive);
               s += this.EndTable();
            }

            // Physical Drive Authentication Table
            var oCtrl = oSSD.m_oCtrl;
            if (typeof (oCtrl) != "undefined" && oCtrl)
            {
               var sCtrlAuthSupport = getAttribute(oCtrl.IdentifyController, "Even More Controller Flags");
               var bCtrlAuthSupport = false;
               if (typeof (sCtrlAuthSupport) != "undefined" && sCtrlAuthSupport != "")
               {
                  bCtrlAuthSupport = sCtrlAuthSupport & 0x4000;
               }
               if (bCtrlAuthSupport)
               {
                  // Display the physical drive authentication table.
                  s += this.Break();
                  s += this.StartTable();
                  s += this.DisplayHeader("Physical Drive Authentication");
                  var sDrvState = getAttribute(oPhysicalDrive, "Drive Authentication");
                  var bDriveAuthSupported = typeof (sDrvState) != "undefined" && sDrvState != "";
                  var sCarState = getAttribute(oPhysicalDrive, "Smart Carrier Authentication");
                  var bCarrierAuthSupported = typeof (sCarState) != "undefined" && sCarState != "";
                  if (!bCarrierAuthSupported || sCarState == 0)
                  {
                     sCarState = "Not Applicable";
                     // Drive authentication is not applicable if carrier 
                     // authentication is not applicable.
                     sDrvState = "Not Applicable";
                  }
                  else
                  {
                     switch (sCarState)
                     {
                        case 1:
                           sCarState = "OK";
                           break;
                        case 2:
                           sCarState = "Failed: Communication Error";
                           break;
                        case 255:
                        default:
                           sCarState = "Failed: This is not an authentic HP carrier";
                           break;
                     }

                     if (!bDriveAuthSupported)
                     {
                        sDrvState = "Not Applicable";
                     }
                     else
                     {
                        switch (sDrvState)
                        {
                           case 0:
                              sDrvState = "Failed: Device failed the first authentication test";
                              break;
                           case 1:
                              sDrvState = "Failed: Device failed the second authentication test";
                              break;
                           case 0x80:
                              sDrvState = "OK";
                              break;
                           default:
                              sDrvState = "Failed: Device failed at least one authentication test";
                              break;
                        }
                     }
                  }
                  // Only show the drive authentication state if it's applicable.
                  if (sDrvState != "Not Applicable")
                  {
                     s += this.DisplayStringPair("Drive Authentication Status",
                                                 sDrvState);
                  }
                  // If controller supports drive and carrier authentication, always 
                  // show the carrier authentication state, even when not applicable.
                  s += this.DisplayStringPair("Drive Carrier Authentication Status",
                                              sCarState);
                  // The two version fields will only contain meaningful data if 
                  // the carrier has authenticated successfully (it's in OK state).
                  if (sCarState == "OK")
                  {
                     s += this.DisplayAttr(oPhysicalDrive, "Smart Carrier Application Version");
                     s += this.DisplayAttr(oPhysicalDrive, "Smart Carrier Bootloader Version");
                  }
                  s += this.EndTable();
               }
            }

            // Location
            var sAttrBox = getAttribute(oPhysicalDrive, "Physical Box");
            var sAttrBay = getAttribute(oPhysicalDrive, "Physical Bay");
            var sAttrPort = getAttribute(oPhysicalDrive, "Physical Port");
            var sLocHTML = "";
            if (typeof (sAttrBox) != "undefined")
            {
               // Convert to int
               sAttrBox = parseInt(sAttrBox);
               sAttrBay = parseInt(sAttrBay);

               s += this.Break();
               s += this.StartTable();
               s += this.DisplayHeader("Location");

               // Display Port
               if (typeof (sAttrPort) != "undefined")
               {
                  s += this.DisplayStringPair("Port", sAttrPort);
               }
               // Display Box
               if (sAttrBox == "0")
               {
                  s += this.DisplayStringPair("Box", "0 (Not Applicable)");
               }
               else
               {
                  s += this.DisplayStringPair("Box", sAttrBox);
               }
               // Display Bay
               if (typeof (sAttrBay) != "undefined")
               {
                  if (sAttrBay == "0" && sAttrBox == "0")
                  {
                     s += this.DisplayStringPair("Bay", "0 (Not Applicable)");
                  }
                  else
                  {
                     s += this.DisplayStringPair("Bay", sAttrBay);
                  }
               }
               // Display Location Hint
               var sLocHint = getAttribute(oPhysicalDrive, "Location Hint");
               if (typeof (sLocHint) != "undefined" && sLocHint != "None")
               {
                  s += this.DisplayAttr("Location Hint");
               }
               s += this.EndTable();
               s += '</div>';
            }
            //            else
            //            {
            //               sLocHTML += this.DisplayAttr(ATTR_NAME_SCSI_BUS);
            //               sLocHTML += this.DisplayAttr(ATTR_NAME_SCSI_ID);
            //            }
         }

         var o = GE(m_sInfoID);
         if (o)
         {
            o.innerHTML = s;
         }
      }

      this.StartTable = function()
      {
         return '<table class="moreInfoTable" cellspacing="0">';
      }

      this.EndTable = function()
      {
         return "</table>";
      }

      this.Break = function()
      {
         return "<br/>";
      }

      this.DisplayHeader = function(sTitle)
      {
         return '<tr><td class="moreInfoHeader" colspan="2">' +
              sTitle +
              '</td></tr>';
      }

      this.DisplayTemp = function(sAttrName, deviceIn, sDisplayName)
      {
         var sHTML = "";
         var attrValue = getAttribute(deviceIn, sAttrName);
         if (typeof (attrValue) != "undefined" && attrValue != "" 
             && attrValue > 0 && attrValue != 0xFF)
         {
            // Translate to int
            var convertedValue = parseInt(attrValue);
            if (typeof (sDisplayName) != "undefined" && sDisplayName != "")
            {
               sHTML = this.DisplayStringPair(sDisplayName, convertedValue + "&deg;C");
            }
            else
            {
               sHTML = this.DisplayStringPair(sAttrName, convertedValue + "&deg;C");
            }
         }
         return sHTML;
      }

      // Toggles the shade of the cell to be displayed next in a table and 
      // returns which shade to be used now.
      this.getAlt = function()
      {
         var sAltClass = m_isAlt ? m_sAltClass : "";
         m_isAlt = !m_isAlt;
         return sAltClass;
      }

      this.resetAlt = function()
      {
         m_isAlt = 0;
      }

      this.DisplayString = function(sValue)
      {
         return "<tr><td class=\"moreInfoValue" + this.getAlt() + "\" colspan=2>" + sValue + "</td></tr>";

      }

      this.DisplayStringPair = function(sLabel, sValue, sValueId, bNumber)
      {
         if (sValue == "")
         {
            if (bNumber)
            {
               sValue = "0";
            }
            else
            {
               sValue = "&nbsp;";
            }
         }
         return "<TR><TD class=\"moreInfoLabel\">" + sLabel + "</TD><TD class=\"moreInfoValue" + this.getAlt() + "\"" + (sValueId ? " id=" + sValueId : "") + ">" + sValue + "</TD></TR>";
      }

      this.DisplayAttr = function(sAttrName, sTableName, sDisplayName, deviceIn, sValueId)
      {
         var sHTML = "";
         if (typeof (deviceIn) == "undefined")
         {
            deviceIn = m_oTree.getSelected().m_oDevice;
         }
         var attrValue = "";
         if (sTableName == "PhysicalDriveStatus")
         {
            attrValue = getAttribute(deviceIn.PhysicalDriveStatus, sAttrName);
         }
         else if (sTableName == "PhysicalDriveInfo")
         {
            attrValue = getAttribute(deviceIn.PhysicalDriveInfo, sAttrName);
         }
         else
         {
            attrValue = getAttribute(deviceIn.SmartSSDWearGauge, sAttrName);
         }
         // Convert value from hex to dec.
         if (sAttrName == "PHY Count" && 
             typeof (attrValue) != "undefined" && attrValue != "")
         {
            attrValue = parseInt(attrValue, 16);
         }
         if (typeof (attrValue) != "undefined" && attrValue != "")
         {
            if (typeof (sDisplayName) != "undefined" && sDisplayName != "")
            {
               sHTML = this.DisplayStringPair(sDisplayName, attrValue, sValueId);
            }
            else
            {
               sHTML = this.DisplayStringPair(sAttrName, attrValue, sValueId);
            }
         }
         return sHTML;
      }

      this.DisplaySize = function(sAttrName, sTableName, sDisplayName, deviceIn, sValueId)
      {
         var sHTML = "";
         if (typeof (deviceIn) == "undefined")
         {
            deviceIn = m_oTree.getSelected().m_oDevice;
         }
         var attrValue = ""
         if (sTableName == "PhysicalDriveStatus")
         {
            attrValue = getAttribute(deviceIn.PhysicalDriveStatus, sAttrName);
         }
         else if (sTableName == "PhysicalDriveInfo")
         {
            attrValue = getAttribute(deviceIn.PhysicalDriveInfo, sAttrName);
         }
         else
         {
            attrValue = getAttribute(deviceIn.SmartSSDWearGauge, sAttrName);
         }
         if (typeof (attrValue) != "undefined" && attrValue != "")
         {
            attrValue = parseInt(attrValue);
            if (typeof (sDisplayName) == "undefined" && sDisplayName != "")
            {
               sHTML = this.DisplayStringPair(sDisplayName, attrValue, sValueId, true);
            }
            else
            {
               sHTML = this.DisplayStringPair(sAttrName, attrValue, sValueId, true);
            }
         }
         return sHTML;
      }

      this.DisplayStatusTable = function(sIcon, sTitle, sNote, oDevices)
      {
         var s = "";
         s += this.Break();
         s += this.StartTable();
         if (g_isViewer)
         {
            s += this.DisplayHeader(sTitle);
         }
         else
         {
            s += this.DisplayHeader(sIcon + sTitle);
         }
         if (typeof (sNote) != "undefined" && sNote != "")
         {
            s += this.DisplayString(sNote);
         }
         for (var i = 0; i < oDevices.length; ++i)
         {
            var sID = oDevices[i].m_oDevice.id;
            var sLink = "<a href=# onclick='g_oSmartSSDWearGaugeReport.selectElement(\"" + sID + "\"); return false;'>" + oDevices[i].getTitle(true, false) + "</a>";
            s += this.DisplayString(sLink);
         }
         s += this.EndTable();
         return s;
      }

      this.DisplayStringTable = function(sTitle, oStrings)
      {
         var s = "";
         if (oStrings && oStrings.length > 0)
         {
            s += this.Break();
            s += this.StartTable();
            s += this.DisplayHeader(sTitle);
            for (var i = 0; i < oStrings.length; ++i)
            {
               s += this.DisplayString(oStrings[i]);
            }
            s += this.EndTable();
         }
         return s;
      }

      this.DisplayPageHeader = function(sTitle, sIcon, sOverlayIcon)
      {
         var s = '<table class="' + g_sSSDInfoHeaderClass + '"><tr>';
         if (!g_isViewer)
         {
            s += '<td style="width:80px; padding-top:7px;padding-bottom:7px;">' +
              filterIcon(sIcon, "60px", "60px", "") +
              sOverlayIcon + '</td>';
         }
         /*s += '<td class="SSDInfoHeaderTitle">' +
         sTitle + '</td>' + '<td style="text-align:right;">';*/
         s += '<td style="text-align:left;"><table class="SSDInfoHeaderTitle"><tr><td>' +
              sTitle + '</td></tr></table></td>' + '<td style="text-align:right;">';

         s += '</td></tr></table>';
         return s;
      }

      // Displays the summary box to the right of the tree.
      this.DrawSummary = function()
      {
         this.resetAlt();
         var oSSDWearoutList = this.m_oSSDContainer.getSSDs("Has Smart Trip SSD Wearout", "TRUE");
         var oSSD56DaysList = this.m_oSSDContainer.getSSDs("Has 56 Day Warning", "TRUE");
         var oSSD5PercentList = this.m_oSSDContainer.getSSDs("Has Utilization Warning", "5PERCENT");
         var oSSD2PercentList = this.m_oSSDContainer.getSSDs("Has Utilization Warning", "2PERCENT");
         var oSSDs = this.m_oSSDContainer.getSSDs();
         var nTotalWearouts = oSSDWearoutList.length;
         var nTotalSSDs = oSSDs.length;
         var nTotalSmartArraySSDs = 0;
         var nTotalNonSmartArraySSDs = 0;
         var nTotalSASSSDs = 0;
         var nTotalSATASSDs = 0;
         var bHasWearout = nTotalWearouts > 0;
         var bHas56Days = oSSD56DaysList.length > 0;
         var bHas2Percent = oSSD2PercentList.length > 0;
         var bHas5Percent = oSSD5PercentList.length > 0;

         m_oTree.clearSelected();
         var sTitle = "SmartSSD Wear Gauge Summary";
         var sIcon = "images/sasdrive60.png";
         var sOverlayIcon = "";
         if (!g_isViewer)
         {
            if (bHasWearout)
            {
               sOverlayIcon = "images/degraded36.png";
            }
            else if (bHas56Days || bHas2Percent || bHas5Percent)
            {
               sOverlayIcon = "images/infostat36.png";
            }
            else
            {
               sOverlayIcon = "images/okay36.png";
            }
            sOverlayIcon = filterIcon(sOverlayIcon, '36px', '36px', 'TaskOverlay');
         }
         // Draw header.
         var s = this.DisplayPageHeader(sTitle, sIcon, sOverlayIcon);

         // Div containing summary content.
         s += '<div id="' + m_sInfoTableID + '">';

         // Calculate totals
         var oSSDs = this.m_oSSDContainer.getSSDs();

         for (var i = 0; i < nTotalSSDs; ++i)
         {
            var sSSDType = oSSDs[i].m_oDevice.deviceType;
            var sSSDInterface;
            if (typeof (sSSDType) != "undefined")
            {
               if (sSSDType == "NonSmartArrayPhysicalDrive")
               {
                  ++nTotalNonSmartArraySSDs;
                  sSSDInterface = getAttribute(oSSDs[i].m_oDevice.PhysicalDriveInfo, "Interface");
               }
               else
               {
                  ++nTotalSmartArraySSDs;
                  var interfaceValue = getAttribute(oSSDs[i].m_oDevice.PhysicalDriveStatus, "Device Type");
                  if (interfaceValue == "0x02")
                  {
                     sSSDInterface = "SAS_SSD"
                  }
                  else
                  {
                     sSSDInterface = "SATA_SSD"
                  }
               }
            }
            if (typeof (sSSDInterface) != "undefined")
            {
               if (sSSDInterface == "SAS_SSD")
               {
                  ++nTotalSASSSDs;
               }
               else if (sSSDInterface == "SATA_SSD")
               {
                  ++nTotalSATASSDs;
               }
            }
         }

         // Draw summary table
         s += this.StartTable();
         s += this.DisplayHeader("Summary");
         s += this.DisplayStringPair("Total Solid State Drives with Wearout Status", nTotalWearouts, "", true);
         s += this.DisplayStringPair("Total Smart Array Solid State Drives", nTotalSmartArraySSDs, "", true);
         s += this.DisplayStringPair("Total Non Smart Array Solid State Drives", nTotalNonSmartArraySSDs, "", true);
         s += this.DisplayStringPair("Total Solid State SAS Drives", nTotalSASSSDs, "", true);
         s += this.DisplayStringPair("Total Solid State SATA Drives", nTotalSATASSDs, "", true);
         s += this.DisplayStringPair("Total Solid State Drives", nTotalSSDs, "", true);
         s += this.EndTable();

         // List SSDs with wearout if any exists.
         var sSSDClass;
         if (g_isMoz)
         {
            sSSDClass = "SSDTableIconFF";
         }
         else
         {
            sSSDClass = "SSDTableIconIE";
         }
         if (bHasWearout)
         {
            s += this.DisplayStatusTable(filterIcon("images/degraded12.png", "12px", "12px", sSSDClass),
               "Solid State Drives with Wearout Status",
               "Note: The following listed SSDs have reached the maximum rated usage limit for writes (wearout) and should be replaced immediately.",
               oSSDWearoutList);
         }
         var sInfoIcon12 = filterIcon("images/infostat12.png", "12px", "12px", sSSDClass);

         // Table: SSDs with 56 days warning.
         if (oSSD56DaysList.length > 0)
         {
            s += this.DisplayStatusTable(sInfoIcon12, "Solid State Drives with Less Than an Estimated 56 Days of Life Remaining",
               "Note: The following listed SSDs have less than an estimated 56 days of life remaining before wearout and should be replaced as soon as possible.", oSSD56DaysList);
         }

         // Table: SSDs with 2% usage remaining warning.
         if (oSSD2PercentList.length > 0)
         {
            s += this.DisplayStatusTable(sInfoIcon12, "Solid State Drives with Less Than 2% Usage Remaining",
               "Note: The following listed SSDs have less than 2% usage remaining before wearout.", oSSD2PercentList);
         }

         // Table: SSDs with 5% usage remaining warning.
         if (oSSD5PercentList.length > 0)
         {
            s += this.DisplayStatusTable(sInfoIcon12, "Solid State Drives with Less Than 5% Usage Remaining",
               "Note: The following listed SSDs have less than 5% usage remaining before wearout.", oSSD5PercentList);
         }

         //s += this.DisplayStatusTable(sInfoIcon12, "Display All", "For debug purpose", oSSDs);

         var oCtrls = this.m_oSSDContainer.getCtrls();
         var oSACtrlHTML = new Array();
         var oNSACtrlHTML = new Array();

         for (var j = 0; j < oCtrls.length; ++j)
         {
            var sCtrlLabel = oCtrls[j].marketingName;
            if (oCtrls[j].deviceType == "NonSmartArrayController")
            {
               oNSACtrlHTML[oNSACtrlHTML.length] = sCtrlLabel;
               break;
            }
            else if (oCtrls[j].deviceType == "ArrayController")
            {
               oSACtrlHTML[oSACtrlHTML.length] = sCtrlLabel;
               break;
            }
         }

         // Smart Array Controllers Table.
         this.DisplayStringTable("Smart Array Controllers", oSACtrlHTML);

         // Non Smart Array Controllers Table.
         this.DisplayStringTable("Non Smart Array Controllers", oNSACtrlHTML);

         // Close div containing summary content.
         s += '</div>';

         var o = GE(m_sInfoID);
         o.innerHTML = s;
      }
   }

   function CSSD(oCtrl, oDevice)
   {
      this.m_oCtrl = oCtrl;
      this.m_oDevice = oDevice;

      // Save these attribute for future use so we do not have to calculate every time.
      this.m_sStatusText = "";
      this.m_nStatus = 999; // 1=Failed 2=Warning 3=Informational 4=OK
      this.m_sStatusGroup = "";
      this.m_sPhysicalStatus;
      this.m_sDaysRemaining = "";
      this.m_sUsageRemaining = "-1";
      this.m_nSize = "";
      this.m_sInterface = "";
      this.m_sInterfaceShort = "";
      this.m_sAttrBox = "";
      this.m_sAttrBay = "";
      this.m_sAttrPort = "";
      this.m_sLocation = "";
      this.m_sLabel = "";
      this.m_sCtrlType = "";
      this.m_bSmartSSDSupported;

      // Days remaining
      this.m_sDaysRemaining = getAttribute(oDevice.SmartSSDWearGauge, "Remaining Days Until Wearout");

      // Usage Remaining
      var nUtilization = getAttribute(oDevice.SmartSSDWearGauge, "Utilization");
      var bValidLifeLeft = typeof (nUtilization) != "undefined" && nUtilization >= 0 && nUtilization <= 100;
      if (bValidLifeLeft)
      {
         this.m_sUsageRemaining = 100 - nUtilization;
      }

      // Physical Status
      this.m_sPhysicalStatus = getAttribute(oDevice.SmartSSDWearGauge, "Status");
      if (typeof (this.m_sPhysicalStatus) != "undefined")
      {
         // Translate the attribute values
         switch (this.m_sPhysicalStatus)
         {
            case "PREDICTIVE_FAILURE":
               this.m_sPhysicalStatus = "Predictive Failure";
               break;
            case "QUEUED_FOR_ERASE":
               this.m_sPhysicalStatus = "Queued For Erase";
               break;
            case "ERASE_IN_PROGRESS":
               this.m_sPhysicalStatus = "Erase In Progress";
               break;
            case "ERASE_COMPLETED":
               this.m_sPhysicalStatus = "Erase Completed";
               break;
            case "ERASE_FAILED":
               this.m_sPhysicalStatus = "Erase Failed";
               break;
            case "ERASE_ABORTED":
               this.m_sPhysicalStatus = "Erase Aborted";
               break;
            case "REBUILDING":
               this.m_sPhysicalStatus = "Rebuilding";
               break;
            case "FAILED":
               this.m_sPhysicalStatus = "Failed";
               break;
            case "TRANSIENT_DATA_DRIVE":
               this.m_sPhysicalStatus = "Transient Data Drive";
               break;
            default:
               break;
         }
      }

      // SmartSSDSupported
      var sSupported = getAttribute(oDevice.SmartSSDWearGauge, "Supported");
      if (typeof (sSupported) == "undefined" || sSupported == "FALSE")
      {
         this.m_bSmartSSDSupported = false;
      }
      else
      {
         this.m_bSmartSSDSupported = true;
      }

      // Status
      var sStatus = getAttribute(oDevice.SmartSSDWearGauge, "Status");
      var sSmartTrip = getAttribute(oDevice.SmartSSDWearGauge, "Has Smart Trip SSD Wearout");
      var sUtiizationWarning = getAttribute(oDevice.SmartSSDWearGauge, "Has Utilization Warning");
      var s56DaysWarning = getAttribute(oDevice.SmartSSDWearGauge, "Has 56 Day Warning");
      var bSmartTrip = typeof (sSmartTrip) != "undefined" && sSmartTrip == "TRUE";
      if (typeof (sStatus) != "undefined" && sStatus == "FAILED")
      {
         this.m_nStatus = 1; // This is Failed level
         this.m_sStatusText = sStatus;
         this.m_sStatusGroup = "Failed Status";
         if (bSmartTrip)
         {
            this.m_sStatusText = "SSD has reached the maximum rated usage limit for writes (wearout) and should be replaced immediately.";
         }
         g_oOverallStatus.FailedCount++;
      }
      else if (bSmartTrip)
      {
         this.m_nStatus = 2; // This is warning level
         this.m_sStatusText = "SSD has reached the maximum rated usage limit for writes (wearout) and should be replaced immediately.";
         this.m_sStatusGroup = "Warning Status";

         g_oOverallStatus.WarningCount++;
      }
      else
      {
         if (typeof (s56DaysWarning) != "undefined" && s56DaysWarning == "TRUE")
         {
            this.m_nStatus = 3; // This is info level
            this.m_sStatusGroup = "Informational Status";
            this.m_sStatusText = "SSD has less than an estimated 56 days before it reaches the maximum usage limit for writes (wearout) and should be replaced as soon as possible.";
         }
         if (typeof (sUtiizationWarning) != "undefined" && sUtiizationWarning != "NONE")
         {
            this.m_nStatus = 3; // This is info level
            this.m_sStatusGroup = "Informational Status";
            if (sUtiizationWarning == "5PERCENT")
            {
               if (this.m_nStatus != 999)
               {
                  this.m_sStatusText = "SSD has less than 5% of usage remaining before wearout. It has less than an estimated 56 days before it reaches the maximum usage limit and should be replaced as soon as possible.";
               }
               else
               {
                  this.m_sStatusText = "SSD has less than 5% of usage remaining before wearout. It has less than an estimated 56 days before it reaches the maximum usage limit and should be replaced as soon as possible.";
               }
            }
            else if (sUtiizationWarning == "2PERCENT")
            {
               if (this.m_nStatus != 999)
               {
                  this.m_sStatusText = "SSD has less than 2% of usage remaining before wearout. It has less than an estimated 56 days before it reaches the maximum usage limit and should be replaced as soon as possible.";
               }
               else
               {
                  this.m_sStatusText = "SSD has less than 2% usage remaining before wearout.";
               }
            }
         }

         if (this.m_nStatus == 3)
         {
            g_oOverallStatus.InfoCount++;
         }
      }

      // Check for other warning status such as PREDICTIVE_FAILURE, rebuilding...
      if (typeof (sStatus) != "undefined" && sStatus != "OK")
      {
         if (this.m_nStatus == 999)
         {
            g_oOverallStatus.WarningCount++;
         }
         if (this.m_nStatus == 3)
         {
            g_oOverallStatus.InfoCount--;
            g_oOverallStatus.WarningCount++;
         }
         this.m_nStatus = 2; // This is warning level
         this.m_sStatusGroup = "Warning Status";
      }

      // Check for log full
      var sSmartSSDLogFull = getAttribute(oDevice.SmartSSDWearGauge, "Log Full");
      if (sSmartSSDLogFull != "undefined" && sSmartSSDLogFull == "TRUE")
      {
         if (this.m_nStatus == 999)
         {
            g_oOverallStatus.WarningCount++;
         }
         if (this.m_nStatus == 3)
         {
            g_oOverallStatus.InfoCount--;
            g_oOverallStatus.WarningCount++;
         }
         this.m_nStatus = 2; // This is warning level
         this.m_sStatusGroup = "Warning Status";
      }

      // If still don't have a status, it must be ok.
      if (this.m_nStatus == 999)
      {
         this.m_nStatus = 4; // This is OK level
         this.m_sStatusGroup = "OK Status";
         this.m_sStatusText = "OK";
      }
      if (this.m_sStatusText == "")
      {
         this.m_sStatusText = "OK";
      }

      var sSSDType = oDevice.deviceType;
      var oPhysicalDriv, sPhysicalDrive;
      var sSSDInterface, sSerialNumber, sFirmwareRevision;
      if (typeof (sSSDType) != "undefined")
      {
         if (sSSDType == "NonSmartArrayPhysicalDrive")
         {
            this.m_sCtrlType = "NON_SMART";
            oPhysicalDrive = oDevice.PhysicalDriveInfo;
            sPhysicalDrive = "PhysicalDriveInfo";
            var interfaceValue = getAttribute(oPhysicalDrive, "Interface");
            if (interfaceValue == "SAS_SSD")
            {
               this.m_sInterface = "Solid State SAS Drive";
               this.m_sInterfaceShort = "SAS SSD";
            }
            else
            {
               this.m_sInterface = "Solid State SATA Drive";
               this.m_sInterfaceShort = "SATA SSD";
            }
         }
         else
         {
            this.m_sCtrlType = "SMART";
            oPhysicalDrive = oDevice.PhysicalDriveStatus;
            sPhysicalDrive = "PhysicalDriveStatus";
            var interfaceValue = getAttribute(oPhysicalDrive, "Device Type");
            if (interfaceValue == "0x02")
            {
               this.m_sInterface = "Solid State SAS Drive"
               this.m_sInterfaceShort = "SAS SSD";
            }
            else
            {
               this.m_sInterface = "Solid State SATA Drive"
               this.m_sInterfaceShort = "SATA SSD";
            }
         }
      }

      // Size
      var size = parseInt(getAttribute(oPhysicalDrive, "Total Blocks"));
      this.m_nSize = ConverToMarketingSize(size);

      // Location
      var sAttrBox = getAttribute(oPhysicalDrive, "Physical Box");
      var sAttrBay = getAttribute(oPhysicalDrive, "Physical Bay");
      var sAttrPort = getAttribute(oPhysicalDrive, "Physical Port");
      if (typeof (sAttrBox) != "undefined")
      {
         // Convert to int
         this.m_sAttrBox = parseInt(sAttrBox);
         this.m_sAttrBay = parseInt(sAttrBay);
         this.m_sAttrPort = sAttrPort;
         this.m_sLocation = "Port " + this.m_sAttrPort + " : Box " + this.m_sAttrBox + " : Bay " + this.m_sAttrBay;
      }
   }
   CSSD.prototype.Destructor = function()
   {
      this.m_oCtrl = null;
      this.m_oDevice = null;
   }
   CSSD.prototype.isSmartSSDSupported = function()
   {
      return this.m_bSmartSSDSupported;
   }
   CSSD.prototype.getPhysicalStatus = function()
   {
      return this.m_sPhysicalStatus;
   }
   CSSD.prototype.getStatus = function()
   {
      return this.m_nStatus;
   }
   CSSD.prototype.getStatusGroup = function()
   {
      return this.m_sStatusGroup;
   }
   CSSD.prototype.getStatusText = function()
   {
      return this.m_sStatusText;
   }
   CSSD.prototype.getInterface = function()
   {
      return this.m_sInterface;
   }
   CSSD.prototype.getDaysRemaining = function()
   {
      return this.m_sDaysRemaining;
   }
   CSSD.prototype.getUsageRemaining = function()
   {
      return this.m_sUsageRemaining;
   }
   CSSD.prototype.getDriveSize = function()
   {
      return this.m_nSize;
   }
   CSSD.prototype.getTitle = function(bIncludeCtrl, bIncludeUsage)
   {
      var sLabel = "";

      // Usage
      if (typeof (bIncludeUsage) != "undefined" && bIncludeUsage)
      {
         if (this.m_sUsageRemaining != "-1")
         {
            var nBarLifeLeft;
            if (this.m_sUsageRemaining >= 5)
            {
               nBarLifeLeft = Math.floor(this.m_sUsageRemaining);
            }
            else if (this.m_sUsageRemaining < 5)
            {
               nBarLifeLeft = this.m_sUsageRemaining.toFixed(2);
            }
            sLabel += "(Usage Remaining: " + nBarLifeLeft + "%) ";
         }
      }

      // Always include size
      sLabel += this.m_nSize;

      // Include interface for smart array. 
      if (this.m_sCtrlType == "SMART")
      {
         sLabel += " " + this.m_sInterfaceShort;
      }
      else
      {
         // Use short name for labels
         var sCtrlName = this.m_oDevice.marketingName;
         sCtrlName = sCtrlName.replace("Solid State SAS Drive", "SAS SSD");
         sCtrlName = sCtrlName.replace("Solid State SATA Drive", "SATA SSD");
         sLabel += " " + sCtrlName;
      }

      // Controller name
      if (typeof (bIncludeCtrl) != "undefined" && bIncludeCtrl)
      {
         // Use short name for labels
         var sCtrlName = this.m_oCtrl.marketingName;
         sCtrlName = sCtrlName.replace("Solid State SAS Drive", "SAS SSD");
         sCtrlName = sCtrlName.replace("Solid State SATA Drive", "SATA SSD");
         sLabel += " on " + sCtrlName;
      }

      // Location
      if (this.m_sLocation != "")
      {
         sLabel += " at " + this.m_sLocation;
      }

      return sLabel;
   }

   // Draws the life bar for the SSD.
   CSSD.prototype.getBar = function(bUseLarge)
   {
      var nPercentLeft = this.m_sUsageRemaining;
      if (nPercentLeft != "-1")
      {
         var nRemainingDays = this.m_sDaysRemaining;
         var nTens = Math.floor(nPercentLeft / 10);
         var nOnes = nPercentLeft % 10;
         if (nOnes > 0 && nOnes < 3)
         {
            nOnes = 0;
         }
         else if (nOnes >= 3 && nOnes < 8)
         {
            nOnes = 5;
         }
         else if (nOnes >= 8 && nOnes < 10)
         {
            ++nTens;
            nOnes = 0;
         }
         if (nOnes == 0 && nTens == 0)
         {
            // 3% icon is used for non-tripped SSDs at 2% or less.
            nOnes = 3;
         }
         if (nTens == 0)
         {
            nTens = "";
         }
         var sSize;
         var sClass;
         if (bUseLarge)
         {
            sSize = "30"
            sClass = "SSDBarLG";
         }
         else
         {
            sSize = "20";
            sClass = "SSDBarSM";
         }
         var sColor;
         if (getAttribute(this.m_oDevice.SmartSSDWearGauge, "Has Smart Trip SSD Wearout") == "TRUE")
         {
            // If failed also, then use failed color: red
            if (getAttribute(this.m_oDevice.SmartSSDWearGauge, "Status") == "Critical")
            {
               sColor = "failed";
               // We have one gauge icon (2%) for both tripped and failed SSDs.
               nTens = "";
               nOnes = 2;
            }
            else
            {
               sColor = "tripped";
               // We have tripped gauge icons up to 10%.
               if (nTens > 0)
               {
                  nTens = 1;
                  nOnes = 0;
               }
               else if (nOnes == 3)
               {
                  // this is specific to the way Bill designed the images.
                  // 2% icon is used for tripped, while 3% is used for non-trip
                  nOnes = 2;
               }
            }
         }
         else if (nPercentLeft <= 5 || (typeof (nRemainingDays) != "undefined" && nRemainingDays <= 56))
         {
            sColor = "blue";
         }
         else if (nTens == 10 && nOnes == 0)
         {
            sColor = "green";
         }
         else
         {
            sColor = "ltgreen";
         }
         // Use a 95% blue icon in place of a 100% blue icon.
         if (nTens == 10 && nOnes == 0 && sColor == "blue")
         {
            nTens = 9;
            nOnes = 5;
         }
         var sImg = "images/" + nTens + nOnes + "percent" + sColor + "gauge" + sSize + ".png";
         return '<img src="' + sImg + '" align="absmiddle" class="' + sClass + '"/>';
      }
      else
      {
         return ""; // not supported
      }
   }

   // Draws the life bar for the SSD.
   CSSD.prototype.getBar2 = function(bUseLarge)
   {
      var nPercentLeft = this.m_sUsageRemaining;
      if (nPercentLeft != "-1")
      {
         var nRemainingDays = this.m_sDaysRemaining;
         var sBGColor2 = "white";
         var sBorderWidth = "2px";
         var sBarHeight = "16px";
         var sBGColor1;
         var sBarLeftWidth;
         var sBarRightWidth;
         if (this.m_sUsageRemaining == 0)
         {
            sBarLeftWidth = "1px"
            sBarRightWidth = "99px"
         }
         else
         {
            sBarLeftWidth = this.m_sUsageRemaining + "px";
            sBarRightWidth = (100 - this.m_sUsageRemaining) + "px";
         }

         if (getAttribute(this.m_oDevice.SmartSSDWearGauge, "Has Smart Trip SSD Wearout") == "TRUE")
         {
            // If failed also, then use failed color: red
            if (this.m_nStatus == 1)
            {
               sBGColor1 = "#CE0000"; // Red
            }
            else
            {
               sBGColor1 = "#FFD600"; // Yellow
            }
         }
         else if (nPercentLeft <= 5 || (typeof (nRemainingDays) != "undefined" && nRemainingDays <= 56))
         {
            sBGColor1 = "#258DED"; // Blue
         }
         else
         {
            sBGColor1 = "#40D929"; // Green
         }
         return '<div class="' + g_sBarClass + '" style="width:' + sBarLeftWidth + '; height:' + sBarHeight + '; ' +
            'border-top:' + sBorderWidth + ' solid ' + sBGColor1 + '; ' +
            'border-bottom:' + sBorderWidth + ' solid ' + sBGColor1 + '; ' +
            'border-left:' + sBorderWidth + ' solid ' + sBGColor1 + '; ' +
            'background-color:' + sBGColor1 + ';"' +
            '></div>' +
            '<div class="' + g_sBarClass + '" style="margin-right:5px; width:' + sBarRightWidth + '; height:' + sBarHeight + '; ' +
            'border-top:' + sBorderWidth + ' solid ' + sBGColor1 + '; ' +
            'border-bottom:' + sBorderWidth + ' solid ' + sBGColor1 + '; ' +
            'border-right:' + sBorderWidth + ' solid ' + sBGColor1 + '; ' +
            'background-color:' + sBGColor2 + ';">' +
            '</div>';
      }
      else
      {
         if (bUseLarge)
         {
            return '';
         }
         else
         {
            return '<div class="' + g_sBarClass + '" style="width:100px; height:16px; border-top:2px solid #F4F4F4; border-left:2px solid #F4F4F4; border-bottom:2px solid #F4F4F4; background-color:#F4F4F4;"></div>' +
            '<div class="' + g_sBarClass + '" style="width:0; height:16px; border-top:2px solid #F4F4F4; border-right:2px solid #F4F4F4; border-top:2px solid #F4F4F4; margin-right:5px;"></div>';
         }
      }
   }

   function CSSDTreeElement(oSSD, oParentTree)
   {
      this.m_sLinkID = CSSDTree.getUID();
      this.m_sLabelID = CSSDTree.getLabelID(this.m_sLinkID);
      this.m_oSSD = oSSD;
      this.m_oLinkDOMElement;
      this.m_oLabelDOMElement;
      this.m_oParentTree = oParentTree;
   }

   CSSDTreeElement.prototype.Destructor = function()
   {
      if (this.m_oSSD != null)
      {
         this.m_oSSD.Destructor();
         this.m_oSSD = null;
      }
      if (this.m_oLinkDOMElement != null)
      {
         this.m_oLinkDOMElement.onmousedown = null;
         this.m_oLinkDOMElement = null;
      }
      this.m_oLabelDOMElement = null;
      this.m_oParentTree = null;
   }

   CSSDTreeElement.prototype.html = function(oPrevParent)
   {
      var sHTML = "";
      oDevice = this.m_oSSD.m_oDevice;

      var sLabel = this.m_oSSD.getTitle(false, true);
      sHTML += "<div class='SSDTreeElement' id=\"" + this.m_sLinkID + "\">";

      if (g_isViewer)
      {
         sHTML += this.m_oSSD.getBar2(false);
      }
      else
      {
         var sIcon = "images/sasssddrive20.png";
         if (this.m_oSSD.getInterface() == "Solid State SATA Drive")
         {
            sIcon = "images/satassddrive20.png";
         }

         // Add node image
         sHTML += filterIcon(sIcon, '20px', '20px', "SSDTreeIcon", this.m_sImageID);

         // Add overlay
         var sOverlay = "images/spacer12.gif";
         var nStatusValue = this.m_oSSD.getStatus();
         if (nStatusValue == 1)
         {
            sOverlay = "images/critical12.png";
         }
         else if (nStatusValue == 2)
         {
            sOverlay = "images/degraded12.png";
         }
         else if (nStatusValue == 3)
         {
            sOverlay = "images/infostat12.png";
         }

         sHTML += '<div class="SSDTreeOverlayIcons">';
         if (sOverlay)
         {
            sHTML += filterIcon(sOverlay, '12px', '12px', "SSDOverlay");
         }
         sHTML += '</div>';
         sHTML += this.m_oSSD.getBar(false);
      }
      sHTML += '<a href=# style="text-decoration:none"><span class="SSDLabel" id="' + this.m_sLabelID + '">' + sLabel + '</span></a></div>';
      return sHTML;
   }

   CSSDTreeElement.prototype.clearSelected = function()
   {
      if (this.m_oLabelDOMElement)
      {
         this.m_oLabelDOMElement.className = "SSDLabel";
      }
   }

   CSSDTreeElement.prototype.blur = function()
   {
      if (this.m_oLabelDOMElement)
      {
         this.m_oLabelDOMElement.className = "SSDLabelBlurred";
      }
   }

   CSSDTreeElement.prototype.focus = function()
   {
      if (this.m_oParentTree.isSelected(this))
      {
         if (this.m_oLabelDOMElement)
         {
            this.m_oLabelDOMElement.className = "SSDLabelSelected";
         }
      }
   }

   CSSDTreeElement.prototype.removeHighlight = function()
   {
      if (this.m_oLabelDOMElement)
      {
         this.m_oLabelDOMElement.className = "SSDLabel";
      }
   }

   CSSDTreeElement.prototype.InitPost = function()
   {
      this.m_oLabelDOMElement = GE(this.m_sLabelID);
      this.m_oLinkDOMElement = GE(this.m_sLinkID);
      if (this.m_oLinkDOMElement)
      {
         this.m_oLinkDOMElement.onclick = CSSDTreeElement.onClick(this);
         disableSelection(this.m_oLinkDOMElement, true);
      }
   }

   // Static functions

   CSSDTreeElement.onClick = function(oSSDTreeElement)
   {
      return (function(e)
      {
         oSSDTreeElement.m_oParentTree.selectElementByID(oSSDTreeElement.m_oSSD.m_oDevice.id);
      });
   }

   CSSDTreeElement.onMouseOver = function(oSSDTreeElement)
   {
      return (function(e)
      {
         oSSDTreeElement.onMouseOver();
      });
   }

   CSSDTreeElement.onMouseOut = function(oSSDTreeElement)
   {
      return (function(e)
      {
         oSSDTreeElement.onMouseOut();
      });
   }

   function CSSDTreeGroup(sLabel, sGroupBy, sIcon)
   {
      this.m_sLinkID = CSSDTree.getUID();
      this.m_sGroupID = CSSDTree.getGroupID(this.m_sLinkID); // Used for hiding the elements in this group.
      this.m_sImageID = CSSDTree.getImageID(this.m_sLinkID);
      this.m_sLabelID = CSSDTree.getLabelID(this.m_sLinkID);
      this.m_sBtnID = CSSDTree.getBtnID(this.m_sLinkID);
      this.m_sGroupBy = sGroupBy;
      this.m_sLabel = sLabel;
      this.m_sIcon = sIcon;
      this.m_bExpanded = true; // true or false if group is expanded.
      this.m_oLinkDOMElement = null;
      this.m_oLabelDOMElement = null;
   }

   CSSDTreeGroup.prototype.Destructor = function()
   {
      if (this.m_oLinkDOMElement != null)
      {
         this.m_oLinkDOMElement.onmousedown = null;
         this.m_oLinkDOMElement = null;
      }
      this.m_oLabelDOMElement = null;
   }

   CSSDTreeGroup.prototype.getIcon = function()
   {
      if (this.m_bExpanded == true)
      {
         return g_sTreeContractBtn;
      }
      else
      {
         return g_sTreeExpandBtn;
      }
   }

   CSSDTreeGroup.prototype.count = function()
   {
      return 0;
   }

   CSSDTreeGroup.prototype.html = function()
   {
      var nCount = this.count();
      var sHTML = "";
      sHTML += "<div class='SSDTreeGroup' id=\"" + this.m_sLinkID + "\">";
      if (g_isViewer)
      {
         sHTML += "<div id='" + this.m_sBtnID + "' class='" + g_sTreeToggleClass + "'>" + this.getIcon() + "</div>";
      }
      else
      {
         sHTML += "<img id='" + this.m_sBtnID + "' class='" + g_sTreeToggleClass + "' align=\"absmiddle\" src='" + this.getIcon() + "'/>";
         sHTML += filterIcon(this.m_sIcon, '20px', '20px', 'SSDTreeImage', this.m_sImageID);
      }
      sHTML += '<a href=# style="text-decoration:none"><span class="SSDGroupLabel" id="' + this.m_sLabelID + '">' + this.m_sLabel + '</span></a></div>';
      sHTML += '<span id="' + this.m_sGroupID + '">';
      return sHTML;
   }

   // Toggle group display.
   CSSDTreeGroup.prototype.toggle = function()
   {
      var o = GE(this.m_sGroupID);
      var oBtn = GE(this.m_sBtnID);
      // If currently hidden, we want to show it, otherwise we want to hide it.
      this.m_bExpanded = (o.style.display == "none");
      if (this.m_bExpanded)
      {
         o.style.display = "block";
         if (g_isViewer)
         {
            oBtn.innerHTML = g_sTreeContractBtn;
         }
         else
         {
            oBtn.src = g_sTreeContractBtn;
         }
      }
      else
      {
         o.style.display = "none";
         if (g_isViewer)
         {
            oBtn.innerHTML = g_sTreeExpandBtn;
         }
         else
         {
            oBtn.src = g_sTreeExpandBtn;
         }
      }
   }

   CSSDTreeGroup.prototype.collapse = function()
   {
      var o = GE(this.m_sGroupID);
      var oBtn = GE(this.m_sBtnID);
      o.style.display = "none";
      if (g_isViewer)
      {
         oBtn.innerHTML = g_sTreeExpandBtn;
      }
      else
      {
         oBtn.src = g_sTreeExpandBtn;
      }
   }

   CSSDTreeGroup.prototype.expand = function()
   {
      var o = GE(this.m_sGroupID);
      var oBtn = GE(this.m_sBtnID);
      o.style.display = "block";
      if (g_isViewer)
      {
         oBtn.innerHTML = g_sTreeContractBtn;
      }
      else
      {
         oBtn.src = g_sTreeContractBtn;
      }
   }

   CSSDTreeGroup.prototype.InitPost = function()
   {
      this.m_oLabelDOMElement = GE(this.m_sLabelID);
      this.m_oLinkDOMElement = GE(this.m_sLinkID);
      this.m_oLinkDOMElement.onclick = CSSDTreeGroup.onClick(this);
      disableSelection(this.m_oLinkDOMElement, true);
      disableSelection(GE(this.m_sImageID), true);
   }

   CSSDTreeGroup.onClick = function(oSSDTreeGroup)
   {
      return (function(e)
      {
         oSSDTreeGroup.toggle();
      });
   }

   function CSSDTree(oParent, sTreeID, sLinkID)
   {

      var m_sTreeID = sTreeID;
      var m_sSelectedBtn = "images/themes/blue/button_tree_expand.gif";
      var m_sNonSelectBtn = "images/themes/blue/button_tree_contract.gif";
      var m_sLinkID = sLinkID;
      var m_sGroupBy = SSD_GROUP_BY_CONTROLLER;
      var m_sSortBy = SSD_SORT_BY_WEAR;
      var m_sFilterBy = SSD_FILTER_BY_ALL;
      var m_nSelected = -1;
      var m_oTreeElements = null;
      var m_oTreeGroups = null;
      var m_oLinkDOMElement = null;
      this.m_oParent = oParent;

      function isValidSelection(nIndex)
      {
         return nIndex >= 0 && nIndex < m_oTreeElements.length;
      }

      // Returns true if given index is the selected index, false otherwise.
      this.isSelected = function(oTreeElement)
      {
         //return m_nSelected == nIndex;
         return m_oTreeElements[m_nSelected] == oTreeElement;
      }

      this.clearSelected = function()
      {
         if (isValidSelection(m_nSelected))
         {
            m_oTreeElements[m_nSelected].clearSelected();
         }
         m_nSelected = -1;
      }

      this.getSelected = function()
      {
         if (isValidSelection(m_nSelected))
         {
            return m_oTreeElements[m_nSelected].m_oSSD;
         }
         else
         {
            return null;
         }
      }

      this.selectElementByID = function(sID)
      {
         var bIsFound = false;
         for (var i = 0; i < m_oTreeElements.length && !bIsFound; ++i)
         {
            bIsFound = m_oTreeElements[i].m_oSSD.m_oDevice.id == sID;
            if (bIsFound)
            {
               if (isValidSelection(m_nSelected))
               {
                  m_oTreeElements[m_nSelected].removeHighlight();
               }
               m_nSelected = i;
               m_oTreeElements[m_nSelected].focus();
               this.m_oParent.DrawMoreInfo();
            }
         }
      }

      this.DestroyElements = function()
      {
         if (m_oTreeElements != null)
         {
            for (var i = 0; i < m_oTreeElements.length; ++i)
            {
               m_oTreeElements[i].Destructor();
            }
            m_oTreeElements = null;
         }
      }

      this.DestroyGroups = function()
      {
         if (m_oTreeGroups != null)
         {
            for (var j = 0; j < m_oTreeGroups.length; ++j)
            {
               m_oTreeGroups[j].Destructor();
            }
            m_oTreeGroups = null;
         }
      }

      this.collapseAllNodes = function()
      {
         for (var i = 0; i < m_oTreeGroups.length; ++i)
         {
            m_oTreeGroups[i].collapse();
         }
      }

      this.expandAllNodes = function()
      {
         for (var i = 0; i < m_oTreeGroups.length; ++i)
         {
            m_oTreeGroups[i].expand();
         }
      }

      this.updateGroupBy = function(sVal)
      {
         m_sGroupBy = sVal;
         this.draw();
      }

      this.updateSortBy = function(sVal)
      {
         m_sSortBy = sVal;
         this.draw();
      }

      this.updateFilterBy = function(sVal)
      {
         m_sFilterBy = sVal;
         this.draw();
      }

      function sortStatus(oA, oB)
      {
         var nResult = 0;
         var nA = oA.m_oSSD.getStatus();
         var nB = oB.m_oSSD.getStatus();
         if (nA < nB)
         {
            nResult = -1;
         }
         else if (nA > nB)
         {
            nResult = 1;
         }
         return nResult;
      }

      function sortWear(oA, oB)
      {

         var nResult = 0;
         var nA = parseFloat(oA.m_oSSD.getUsageRemaining());
         if (nA == -1) // Put unknnown usage at the end.
         {
            nA = 99999;
         }
         var nB = parseFloat(oB.m_oSSD.getUsageRemaining());
         if (nB == -1) // Put unknnown usage at the end.
         {
            nB = 99999;
         }
         if (nA < nB) // sort ascending by usage remaining
         {
            nResult = -1;
         }
         else if (nA > nB)
         {
            nResult = 1;
         }
         return nResult;
      }

      function sortDaysLeft(oA, oB)
      {
         var nResult = 0;
         var nA = oA.m_oSSD.getDaysRemaining();
         if (typeof (nA) == "undefined" || nA == "")
         {
            nA = 99999;
         }
         nA = parseInt(nA);
         var nB = oB.m_oSSD.getDaysRemaining();
         if (typeof (nB) == "undefined" || nB == "")
         {
            nB = 99999;
         }
         nB = parseInt(nB);

         if (nA > nB)
         {
            nResult = 1;
         }
         else if (nA < nB)
         {
            nResult = -1;
         }
         return nResult;
      }

      function sortDriveType(oA, oB)
      {
         var nResult = 0;
         var nA = oA.m_oSSD.getInterface();
         var nB = oB.m_oSSD.getInterface();
         if (nA > nB)
         {
            nResult = 1;
         }
         else if (nA < nB)
         {
            nResult = -1;
         }
         return nResult;
      }

      // Returns true if we should draw the tree group.
      this.shouldDrawGroup = function(sGroup)
      {
         // Currently we only hide the OK status group if the filter is set to
         // "Hide OK".
         return m_sFilterBy != SSD_FILTER_BY_HIDE_OK || sGroup != "OK";
      }

      // Returns true if we should draw the tree element.
      this.shouldDrawElement = function(oElem)
      {
         var bResult = false;
         if (m_sFilterBy == SSD_FILTER_BY_ALL)
         {
            bResult = true;
         }
         else if (m_sFilterBy == SSD_FILTER_BY_HIDE_OK)
         {
            if (oElem.m_oSSD.getStatus() != 4) // 4 = OK
            {
               bResult = true;
            }
         }
         else if (m_sFilterBy == SSD_FILTER_BY_SMARTSSD)
         {
            var sSupported = oElem.m_oSSD.isSmartSSDSupported();
            if (typeof (sSupported) != 'undefined' && sSupported != false)
            {
               bResult = true;
            }
         }
         return bResult;
      }

      this.Update = function()//o)
      {
         this.DestroyElements();
         m_oTreeElements = new Array();
         m_nSelected = -1;
         var oSSDs = this.m_oParent.m_oSSDContainer.getSSDs(); //o.m_oSSDContainer.getSSDs();
         for (var i = 0; i < oSSDs.length; ++i)
         {
            m_oTreeElements[m_oTreeElements.length] = new CSSDTreeElement(oSSDs[i], this);
         }
         this.draw();
      }

      this.draw = function()
      {
         this.DestroyGroups();
         m_oTreeGroups = new Array();
         var oGroupIDs = new Array();
         var oGroupHTMLs = new Array();
         var oTree = GE(m_sTreeID);
         var sHTML = "";
         var oSelected;
         if (isValidSelection(m_nSelected))
         {
            oSelected = m_oTreeElements[m_nSelected];
         }
         else
         {
            oSelected = null;
         }
         m_oTreeElements.sort(sortStatus);
         if (m_sSortBy == SSD_SORT_BY_WEAR)
         {
            m_oTreeElements.sort(sortWear);
         }
         else if (m_sSortBy == SSD_SORT_BY_DAYS_LEFT)
         {
            m_oTreeElements.sort(sortDaysLeft);
         }
         else if (m_sSortBy == SSD_SORT_BY_DRIVE_TYPE)
         {
            m_oTreeElements.sort(sortDriveType);
         }
         if (m_sGroupBy == SSD_GROUP_BY_STATUS)
         {
            // If group by status, we want to display the Status order in Critical, Warning, Info and OK.
            // This extra sorting will achieve this purpose.
            m_oTreeElements.sort(sortStatus);
         }

         for (var i = 0; i < m_oTreeElements.length; ++i)
         {
            // Update index of currently selected device,
            // since sorting may have changed it.
            if (oSelected)
            {
               if (m_oTreeElements[i] == oSelected)
               {
                  m_nSelected = i;
               }
            }

            var sGroup = "";
            var sLabel = "";
            var sIcon = "";
            if (m_sGroupBy == SSD_GROUP_BY_CONTROLLER)
            {
               var oGroup = m_oTreeElements[i].m_oSSD.m_oCtrl;
               sGroup = oGroup.id;
               if (typeof (oGroupHTMLs[sGroup]) == "undefined")
               {
                  sLabel = oGroup.marketingName;
                  sIcon = "images/ctrl20.png";
               }
            }
            else if (m_sGroupBy == SSD_GROUP_BY_STATUS)
            {
               var nGroup = m_oTreeElements[i].m_oSSD.getStatus()
               sGroup = m_oTreeElements[i].m_oSSD.getStatusGroup()
               if (typeof (oGroupHTMLs[sGroup]) == "undefined")
               {
                  var sGroupTxt = sGroup;
                  switch (nGroup)
                  {
                     case 4:
                        sIcon = "images/okay20.png";
                        break;
                     case 3:
                        sIcon = "images/infostat20.png";
                        break;
                     case 2:
                        sIcon = "images/degraded20.png";
                        break;
                     case 1:
                        sIcon = "images/critical20.png";
                        break;
                  }
                  sLabel = sGroupTxt;
               }
            }
            if (sLabel != "" && this.shouldDrawGroup(sGroup))
            {
               oGroupIDs[oGroupIDs.length] = sGroup;
               var oSSDTreeGroup = new CSSDTreeGroup(sLabel, m_sGroupBy, sIcon);
               m_oTreeGroups[m_oTreeGroups.length] = oSSDTreeGroup;
               oGroupHTMLs[sGroup] = oSSDTreeGroup.html();
            }
            // Check filter to see if this element should be drawn.
            if (this.shouldDrawElement(m_oTreeElements[i]))
            {
               oGroupHTMLs[sGroup] += m_oTreeElements[i].html();
            }
         }
         for (var j = 0; j < oGroupIDs.length; ++j)
         {
            sHTML += oGroupHTMLs[oGroupIDs[j]] + '</span>';
         }

         oTree.innerHTML = sHTML;
         this.InitPost();
      }

      this.InitPost = function()
      {
         for (var j = 0; j < m_oTreeElements.length; ++j)
         {
            m_oTreeElements[j].InitPost();
         }
         for (var k = 0; k < m_oTreeGroups.length; ++k)
         {
            m_oTreeGroups[k].InitPost();
         }
         if (m_oLinkDOMElement == null)
         {
            m_oLinkDOMElement = GE(m_sLinkID);
            m_oLinkDOMElement.onfocus = CSSDTree.onFocus(this);
            m_oLinkDOMElement.onblur = CSSDTree.onBlur(this);
         }
         m_oLinkDOMElement.focus();
      }

      this.focus = function()
      {
         CSSDTree.bEnableBlur = false;
         setTimeout("try{document.getElementById(\"" + m_sLinkID + "\").focus();}catch(e){}CSSDTree.bEnableBlur=true;", 10);
      }

      this.highlightSelected = function()
      {
         if (isValidSelection(m_nSelected))
         {
            m_oTreeElements[m_nSelected].focus();
         }
      }

      this.blur = function()
      {
         if (isValidSelection(m_nSelected))
         {
            m_oTreeElements[m_nSelected].blur();
         }
      }
   }

   CSSDTree.bEnableBlur = true;
   CSSDTree.onFocus = function(oSSDTree)
   {
      return (function(e)
      {
         oSSDTree.highlightSelected();
      });
   }

   CSSDTree.onBlur = function(oSSDTree)
   {
      return (function(e)
      {
         if (CSSDTree.bEnableBlur)
         {
            oSSDTree.blur();
         }
      });
   }

   CSSDTree.UID = 0; // Stores the current unique ID available to be assigned to a
   // tree element.
   CSSDTree.getUID = function()
   {
      CSSDTree.UID++;
      return "SSDTree" + CSSDTree.UID;
   }

   CSSDTree.getImageID = function(sLinkID)
   {
      return "image" + sLinkID;
   }

   CSSDTree.getLabelID = function(sLinkID)
   {
      return "label" + sLinkID;
   }

   CSSDTree.getGroupID = function(sLinkID)
   {
      return "group" + sLinkID;
   }

   CSSDTree.getBtnID = function(sLinkID)
   {
      return "btn" + sLinkID;
   }

   // Status summary box.
   function CSSDStatus(oParent, sStatusID)
   {
      var m_sStatusID = sStatusID;
      var m_sLinkID = "VIEW_SSD_SUMMARY_ID";
      this.m_oParent = oParent;

      this.draw = function()
      {
         var oMPL = g_sJSONData.SmartSSDWearGaugeReport.MetaPropertyList;

         var sHTML = "<table style='width:100%;'>";
         sHTML += "<tr><td class='reportInfoLeft' style='padding-top:5px;'>Time Generated</td>";
         sHTML += "<td></td><td valign='middle' class='reportInfoRight' style='padding-top:5px;'>";
         sHTML += getAttribute(oMPL, "Time Generated");
         sHTML += "</td></tr>";
         if (g_isViewer)
         {
            /*sHTML += "<tr><td class='reportInfoLeft'>ADU Version</td>";
            sHTML += "<td></td><td valign='middle' class='reportInfoRight'>";
            sHTML += getAppVersion(oMPL);
            sHTML += "</td></tr>";
            */
            sHTML += "<tr><td class='reportInfoLeft'>Diagnostic Module Version</td>";
            sHTML += "<td></td><td valign='middle' class='reportInfoRight'>";
            sHTML += getAttribute(oMPL, "Diagnostic Module Version");
            sHTML += "</td></tr>";

            sHTML += "<tr><td class='reportInfoLeft'>INFOMGR Version</td>";
            sHTML += "<td></td><td valign='middle' class='reportInfoRight'>";
            sHTML += getAttribute(oMPL, "INFOMGR Version");
            sHTML += "</td></tr>";
            sHTML += "<tr><td class='reportInfoLeft' colspan=3></td></tr>";
            sHTML += "<tr><td class='reportInfoRight' style='border-top:1px solid #999;' align='right' valign='middle' colspan='3'>";
            sHTML += "<div style='padding-top:8px;'><a href=# id='" + m_sLinkID + "'>View Summary</a></div>";
            sHTML += "</td></tr>";
         }
         else
         {
            sHTML += "<tr><td valign=\"middle\" colspan=\"3\"><div style='height:18px;border-bottom:1px solid #999;'></div></td></tr>";
            sHTML += "<tr><td style='text-align:left;'>";
            sHTML += "<table class='SSDStatusTable'>";
            sHTML += "<tr><td>" + filterIcon("images/spacer9.gif", '20px', '20px');
            sHTML += "</td></tr>";
            sHTML += "<tr><td>Solid State Drives Overall Status</td></tr></table>";
            sHTML += "</td><td>";
            sHTML += "<table class='SSDStatusTable'><tr>";
            sHTML += "<td width='25' align='middle'>" + filterIcon("images/critical20.png", '20px', '20px') + "</td>";
            sHTML += "<td width='25' align='middle'>" + filterIcon("images/degraded20.png", '20px', '20px') + "</td>";
            sHTML += "<td width='25' align='middle'>" + filterIcon("images/infostat20.png", '20px', '20px') + "</td>";
            sHTML += "</tr><tr>";
            sHTML += "<td align='middle'>" + g_oOverallStatus.FailedCount + "</td>";
            sHTML += "<td align='middle'>" + g_oOverallStatus.WarningCount + "</td>";
            sHTML += "<td align='middle'>" + g_oOverallStatus.InfoCount + "</td>";
            sHTML += "</tr></table>";
            sHTML += "</td><td align='right'>";
            sHTML += "<table class='SSDStatusTable'><tr><td>" + filterIcon("images/spacer9.gif", '20px', '20px');
            sHTML += "</td></tr>";
            sHTML += "<tr><td><a href=# id='" + m_sLinkID + "'>View Summary</a>";
            sHTML += "</td></tr></table></td></tr>";
         }
         sHTML += "</table>";

         var oStatus = GE(m_sStatusID);
         oStatus.innerHTML = sHTML;
         var oLinkDOMElement = GE(m_sLinkID);
         if (oLinkDOMElement)
         {
            oLinkDOMElement.onclick = CSSDStatus.onDrawSummary(this);
         }
      }
   }

   CSSDStatus.onDrawSummary = function(oSSDStatus)
   {
      return (function(e)
      {
         oSSDStatus.m_oParent.DrawSummary();
      });
   }

   function CSSDContainer()
   {
      var m_oCtrls = new Array();
      var m_oSSDs = new Array();

      function findSSDDevices(oDevice, sSSDInterface)
      {
         var oParents = g_sJSONData.SmartSSDWearGaugeReport.DeviceList;
         g_oOverallStatus = new Object;
         g_oOverallStatus.FailedCount = 0;
         g_oOverallStatus.WarningCount = 0;
         g_oOverallStatus.InfoCount = 0;
         var oChildren = new Array();
         for (var i = 0; i < oParents.length; ++i)
         {
            m_oCtrls[i] = oParents[i];
            //printJaveObject(m_oCtrls[i]);
            findSSDs(oParents[i]);
         }
      }

      this.Destructor = function()
      {
         if (m_oCtrls != null)
         {
            for (var i = 0; i < m_oCtrls.length; ++i)
            {
               m_oCtrls[i] = null;
            }
            m_oCtrls = null;
         }
         if (m_oSSDs != null)
         {
            for (var i = 0; i < m_oSSDs.length; ++i)
            {
               m_oSSDs[i].Destructor();
            }
            m_oSSDs = null;
         }
      }

      function findSSDs(oDevice, oParent)
      {
         var oSmartSSD = oDevice.SmartSSDWearGauge;
         if (typeof (oSmartSSD) != "undefined")
         {
            m_oSSDs[m_oSSDs.length] = new CSSD(oParent, oDevice);
         }
         else
         {
            var oDL = oDevice.DeviceList;
            if (typeof (oDL) != "undefined")
            {
               var bIncludeParent = oDevice.deviceType == "ArrayController" ||
                                    oDevice.deviceType == "NonSmartArrayController";
               for (var i = 0; i < oDL.length; ++i)
               {
                  if (bIncludeParent)
                  {
                     findSSDs(oDL[i], oDevice);
                  }
                  else
                  {
                     findSSDs(oDL[i], oParent);
                  }
               }
            }
         }
      }

      this.getCtrls = function()
      {
         return m_oCtrls;
      }

      this.getSSDs = function(sAttrName, sAttrValue)
      {
         if (typeof (sAttrName) != "undefined" && typeof (sAttrValue) != "undefined")
         {
            var oFoundSSDs = new Array();
            for (var i = 0; i < m_oSSDs.length; ++i)
            {
               if (getAttribute(m_oSSDs[i].m_oDevice.SmartSSDWearGauge, sAttrName) == sAttrValue)
               {
                  oFoundSSDs[oFoundSSDs.length] = m_oSSDs[i];
               }
            }
            return oFoundSSDs;
         }
         else
         {
            return m_oSSDs;
         }
      }

      this.Constructor = function()
      {
         findSSDDevices();
      }

      this.Constructor();
   }

   // Contains controls for managing the view and layout of the device tree.
   function CSSDView(oParent, sViewID)
   {
      var m_sViewID = sViewID;
      var m_sCollapseID = "SSD_COLLAPSE_ALL_NODES";
      var m_sExpandID = "SSD_EXPAND_ALL_NODES";
      var m_sGroupByID = "SSD_GROUP_BY";
      var m_sSortByID = "SSD_SORT_BY";
      var m_sFilterByID = "SSD_FILTER_BY";
      var m_oCollapseDOMElement;
      var m_oExpandDOMElement;
      var m_oGroupByDOMElement;
      var m_oSortByDOMElement;
      var m_oFilterByDOMElement;
      this.m_oParent = oParent;
      var m_sGroupBy = SSD_GROUP_BY_CONTROLLER;
      var m_sSortBy = SSD_SORT_BY_WEAR;
      var m_sFilterBy = SSD_FILTER_BY_ALL;
      var m_sViewSettingsClass = g_isMoz ? "SSDViewSettings" : "SSDViewSettingsIE";

      function getOption(sVal, sLabel, sCurrentVal)
      {
         var sHTML = "<option ";
         if (sVal == sCurrentVal)
         {
            sHTML += "selected ";
         }
         sHTML += "value='" + sVal + "'>";
         sHTML += sLabel + "</option>";
         return sHTML;
      }

      this.draw = function()
      {
         var sHTML = "<div class=\"buttonSet buttonsAreLeftAligned\" style=\"margin-top:9px;margin-bottom:0;padding-left:7px;\">";
         sHTML += "<div class=\"bWrapperUp\" style=\"margin-bottom:0;\"><div>";
         if (g_isViewer)
         {
            sHTML += "<button class=\"hpButtonVerySmall\" type=\"button\" id=\"" + m_sExpandID + "\">++</button>";
         }
         else
         {
            sHTML += "<button class=\"hpButtonVerySmall\" type=\"button\" id=\"" + m_sExpandID + "\"><img src=\"images/plus-plus.gif\"></button>";
         }
         sHTML += "</div></div>";
         sHTML += "<div class=\"bWrapperUp\" style=\"margin-bottom:0;\"><div>";
         if (g_isViewer)
         {
            sHTML += "<button class=\"hpButtonVerySmall\" type=\"button\" id=\"" + m_sCollapseID + "\">- -</button>";
         }
         else
         {
            sHTML += "<button class=\"hpButtonVerySmall\" type=\"button\" id=\"" + m_sCollapseID + "\"><img src=\"images/minus-minus.gif\"></button>";
         }
         sHTML += "</div></div>";
         sHTML += "</div>";
         sHTML += "<div class=\"" + m_sViewSettingsClass + "\">";
         sHTML += "<span class='SSDViewLabel'>Group By</span>";
         sHTML += "<select id='" + m_sGroupByID + "'>";
         sHTML += getOption(SSD_GROUP_BY_CONTROLLER, "Controller", m_sGroupBy);
         sHTML += getOption(SSD_GROUP_BY_STATUS, "Status", m_sGroupBy);
         sHTML += "</select>";
         sHTML += "<span class='SSDViewLabel'>Sort By</span>";
         sHTML += "<select id='" + m_sSortByID + "'>";
         sHTML += getOption(SSD_SORT_BY_WEAR, "Wear", m_sSortBy);
         sHTML += getOption(SSD_SORT_BY_DAYS_LEFT, "Days Left", m_sSortBy);
         sHTML += getOption(SSD_SORT_BY_DRIVE_TYPE, "Drive Type", m_sSortBy);
         sHTML += "</select>";
         sHTML += "<span class='SSDViewLabel'>Filter By</span>";
         sHTML += "<select id='" + m_sFilterByID + "'>";
         sHTML += getOption(SSD_FILTER_BY_ALL, "All", m_sFilterBy);
         sHTML += getOption(SSD_FILTER_BY_HIDE_OK, "Hide OK", m_sFilterBy);
         sHTML += getOption(SSD_FILTER_BY_SMARTSSD, "SmartSSD", m_sFilterBy);
         sHTML += "</select>";
         sHTML += "</div><div class=\"clear\"></div>";
         var o = GE(m_sViewID);
         if (o)
         {
            o.innerHTML = sHTML;
         }

         this.InitPost();
      }

      this.updateGroupBy = function(oParent)
      {
         var oOpt = GE(m_sGroupByID);
         if (oOpt)
         {
            m_sGroupBy = oOpt.value;
            oParent.updateGroupBy(m_sGroupBy);
         }
      }

      this.updateSortBy = function(oParent)
      {
         var oOpt = GE(m_sSortByID);
         if (oOpt)
         {
            m_sSortBy = oOpt.value;
            oParent.updateSortBy(m_sSortBy);
         }
      }

      this.updateFilterBy = function(oParent)
      {
         var oOpt = GE(m_sFilterByID);
         if (oOpt)
         {
            m_sFilterBy = oOpt.value;
            oParent.updateFilterBy(m_sFilterBy);
         }
      }

      this.InitPost = function()
      {
         m_oCollapseDOMElement = GE(m_sCollapseID);
         m_oExpandDOMElement = GE(m_sExpandID);
         m_oGroupByDOMElement = GE(m_sGroupByID);
         m_oSortByDOMElement = GE(m_sSortByID);
         m_oFilterByDOMElement = GE(m_sFilterByID);
         m_oCollapseDOMElement.onclick = CSSDView.onCollapseAllNodes(this);
         m_oExpandDOMElement.onclick = CSSDView.onExpandAllNodes(this);
         m_oGroupByDOMElement.onchange = CSSDView.onGroupBy(this);
         m_oSortByDOMElement.onchange = CSSDView.onSortBy(this);
         m_oFilterByDOMElement.onchange = CSSDView.onFilterBy(this);
      }
   }

   CSSDView.onCollapseAllNodes = function(oSSDView)
   {
      return (function(e)
      {
         oSSDView.m_oParent.collapseAllNodes();
      });
   }

   CSSDView.onExpandAllNodes = function(oSSDView)
   {
      return (function(e)
      {
         oSSDView.m_oParent.expandAllNodes();
      });
   }

   CSSDView.onGroupBy = function(oSSDView)
   {
      return (function(e)
      {
         oSSDView.updateGroupBy(oSSDView.m_oParent);
      });
   }

   CSSDView.onSortBy = function(oSSDView)
   {
      return (function(e)
      {
         oSSDView.updateSortBy(oSSDView.m_oParent);
      });
   }

   CSSDView.onFilterBy = function(oSSDView)
   {
      return (function(e)
      {
         oSSDView.updateFilterBy(oSSDView.m_oParent);
      });
   }

   function CRequestor()
   {
      var m_requestor = false; // XMLHttpRequest object
      var m_pfCallback = false; // possible callback function that the user specifies.
      var m_sFalseDataResponse = "FalseDataResponse";
      this.m_attrList = new Array(); // Name/value pairs
      var m_sRequestType = "";
      // Request Callback Support
      var m_cbInstance = 0;
      var m_cbFunc = 0;
      var m_dsw = 0;
      var m_evalResult = true;    // Run the return value through an "eval"

      this.setEvalResult = function(evalResult)
      {
         m_evalResult = evalResult;
      }

      this.setRequestType = function(sType)
      {
         m_sRequestType = sType;
      }

      this.Constructor = function()
      {
         if (document.location.protocol != "hpapp:" && window.XMLHttpRequest)
         {
            try { m_requestor = new XMLHttpRequest(); }
            catch (e)
            {
               alert("Error creating XMLHttpRequest object");
               m_requestor = false;
            }
         }
         else if (window.ActiveXObject)
         {
            try { m_requestor = new ActiveXObject("Microsoft.XMLHTTP"); }
            catch (e)
            {
               alert("Error creating Microsoft.XMLHTTP object");
               m_requestor = false;
            }
         }
      }
      this.Constructor();

      //    requestor.getDevice(<uniqueId>);
      //    requestor.getDevice(<uniqueId>, callBackFunc);
      //    requestor.getDevice(<uniqueId>, this/obj, "callBackFunc");
      this.executeRequest = function(cbInstance, cbFunc)
      {
         var device; // To be a Device object
         // currently set to synchronous mode, so when this next call
         // comes back, our data will be ready to go. 
         var isAsync = false;
         var sURL = m_sRequestType;
         var sParams = this.m_attrList.join("&");
         // Use POST for all requests.
         var sMethodType = "POST";

         if (cbInstance && cbFunc)
         {
            m_cbInstance = cbInstance;
            m_cbFunc = cbFunc;   // public function
            this.sendRequest(sURL, getResult, sMethodType, sParams);
         }
         else if (cbInstance)
         {
            m_cbFunc = cbInstance; // In this case cbInstance is really a private/global function
            this.sendRequest(sURL, getResult, sMethodType, sParams);
         }
         else
         {
            this.sendRequest(sURL, false, sMethodType, sParams);
            return getResult(this.getResponse(), false);
         }
      }

      function getResult(sReturnData, bReturnArray)
      {
         if (sReturnData.length > 5)
         {
            if (sReturnData.substr(0, 3) == "SIG")
            {
               // Examine status string
               g_lockState = sReturnData.substr(3, 2);
               sReturnData = sReturnData.substr(5);

               var continueProcessing = true;
               if (g_lockState != "OK")
               {
                  continueProcessing = InvokeErrorHandler(g_lockState, sReturnData);
               }
               if (continueProcessing)
               {
                  if (m_evalResult)
                  {
                     // Create variable 'd1'. If multiple devices are requested,
                     // they will be returned in the array variable 'ar'
                     eval(sReturnData);
                  }

                  if (m_evalResult)
                  {
                     if (m_cbInstance && m_cbFunc)
                     {
                        eval("m_cbInstance." + m_cbFunc + "(d1)");
                     }
                     else if (m_cbFunc)
                     {
                        m_cbFunc(d1);
                     }
                     // If setDevice() was used to request multiple devices,
                     // then return array 'ar' containing the returned devices.
                     else if (bReturnArray)
                     {
                        return ar;
                     }
                     else
                     {
                        return d1;
                     }
                  }
                  else
                  {
                     if (m_cbInstance && m_cbFunc)
                     {
                        eval("m_cbInstance." + m_cbFunc + "(sReturnData)");
                     }
                     else if (m_cbFunc)
                     {
                        m_cbFunc(sReturnData);
                     }
                     else
                     {
                        return sReturnData;
                     }
                  }
               }
            }
         }
      }

      this.setAttribute = function(name, value)
      {
         this.m_attrList[this.m_attrList.length] = name + "=" + value;
      }

      this.sendRequest = function(sURL, pfCallback, sMethodType, sParams)
      {
         if (m_requestor)
         {
            var x_date = new Date();
            x_startRequestTime = x_date.getTime();
            if (pfCallback)
            {
               m_pfCallback = pfCallback;
               m_requestor.onreadystatechange = getResponseHandler;
               m_requestor.open(sMethodType, sURL, true); // Asynchronous
            }
            else
            {
               m_requestor.open(sMethodType, sURL, false); // Synchronous
            }
            m_requestor.send(sParams);
         }
      }

      function getResponseData()
      {
         var sResponseText = m_sFalseDataResponse;
         if (m_requestor.readyState == 4)
         {
            if (m_requestor.status == 200 || m_requestor.status == 0)
            {
               sResponseText = m_requestor.responseText;
            }
            else
            {
               alert("The connection to the HTTP server has been lost. Check the network connection and server status, then refresh the browser.");
            }
         }
         return sResponseText;
      }

      function getResponseHandler()
      {
         var sResponseData = getResponseData();
         if ((sResponseData != m_sFalseDataResponse) && m_pfCallback)
         {
            m_pfCallback(sResponseData);
         }
      }

      this.getResponse = function()
      {
         return getResponseData();
      }
   }

   // Convert size from blocks to marketing size
   function ConverToMarketingSize(nBlocks)
   {
      if (typeof (nBlocks) == 'undefined' || nBlocks == "")
      {
         return "0 MB";
      }

      var isFound = true;
      var sConverted = "";

      switch (nBlocks)
      {
         // -----------------------------------------------------------------------   
         // 330 MB    <s>   
         //    
         case 644700:        // 330 MB
         case 636508:        // 330 MB on a ROC                  
            sConverted = "330 MB";
            break;

         // -----------------------------------------------------------------------   
         // 550 MB    <s>   
         //    
         case 1091000:       // 550 MB
         case 1082808:       // 550 MB on a ROC                        
            sConverted = "550 MB";
            break;

         // -----------------------------------------------------------------------   
         // 1.05 GB    <s>   
         //    
         case 2051000:       // 1.05 GB
         case 2042808:       // 1.05 GB on a ROC
            sConverted = "1.05 GB";
            break;

         // -----------------------------------------------------------------------   
         // 2.1 GB    <s>   
         //                                
         case 4110000:       // 2.1 GB
            // 2.1 GB on a ROC - calculation OK
            sConverted = "2.1 GB";
            break;

         // -----------------------------------------------------------------------   
         // 4.3 GB    <s>   
         //    
         case 8386000:       // 4.3 GB (Non-LVD)
         case 8380080:       // 4.3 GB (LVD)                           
         case 8377808:       // 4.3 GB on a ROC (Non-LVD)              
         case 8371888:       // 4.3 GB on a ROC (LVD)                  
            sConverted = "4.3 GB";
            break;

         // -----------------------------------------------------------------------   
         // 9.1 GB    <s>   
         //    
         // 9.1 GB (Non-LVD) - calculation OK         
         // 9.1 GB (LVD) - calculation OK             
         case 17765332:       // 9.1 GB on a ROC (LVD)                  
         case 17765308:       // 9.1 GB on a ROC (Non-LVD)              
            sConverted = "9.1 GB";
            break;

         // -----------------------------------------------------------------------   
         // 18.2 GB    <s>   
         //    
         // 18.2 GB - calculation OK                      
         // 18.2 GB (LVD) - calculation OK                
         // 18.2 GB on a ROC (LVD) - calculation OK       
         // 18.2 GB on a ROC (Non-LVD)- calculation OK       

         //------------------------------------------------------------------------   
         // 36 GB SAS    <s>   
         //   
         case 71132960:
            sConverted = "36 GB";
            break;

         //------------------------------------------------------------------------   
         // 60 GB SATA    <s>   
         //   
         case 117210240:
         case 117231408:       // SSD
            sConverted = "60 GB";
            break;

         //------------------------------------------------------------------------   
         // 72 GB SAS    <s>   
         //   
         case 143374738:
            sConverted = "72 GB";
            break;

         //------------------------------------------------------------------------   
         // 100 GB Solid State SAS    <s>   
         //   
         case 195371568:
            sConverted = "100 GB";
            break;

         //------------------------------------------------------------------------   
         // 120 GB SATA    <s>   
         //   
         case 234441648:
            sConverted = "120 GB";
            break;

         //------------------------------------------------------------------------   
         // 146 GB SAS    <s>   
         //   
         case 286749488:
            sConverted = "146 GB";
            break;

         //------------------------------------------------------------------------   
         // 150 GB Solid State SAS    <s>   
         //   
         case 292968750:
            sConverted = "150 GB";
            break;

         //------------------------------------------------------------------------   
         // 160 GB SATA    <s>   
         //   
         case 312581808:
            sConverted = "160 GB";
            break;

         //------------------------------------------------------------------------   
         // 200 GB Solid State SAS    <s>   
         //   
         case 390721968:
            sConverted = "200 GB";
            break;

         //------------------------------------------------------------------------   
         // 250 GB SATA    <s>   
         //   
         case 488397168:
            sConverted = "250 GB";
            break;

         // -----------------------------------------------------------------------   
         // 300 GB    <s>   
         //    
         case 585937500:       // 300 GB on a LVD (or SAS)
         case 585929308:       // 300 GB on a 5i LVD             
            sConverted = "300 GB";
            break;

         case 781250000:       // 400GB SAS
         case 781422768:       // 400GB Solid State SAS
            sConverted = "400 GB";
            break;

         case 879097968:       // 450GB SAS
            sConverted = "450 GB";
            break;

         case 976773168:       // 500GB SATA
            sConverted = "500 GB";
            break;

         case 1172123568:       // 600GB SAS
            sConverted = "600 GB";
            break;

         case 1465149168:       // 750GB SATA
            sConverted = "750 GB";
            break;

         case 1562824368:       // 800GB Solid State SAS
            sConverted = "800 GB";
            break;

         case 1953525168:      // 1TB SATA
            sConverted = "1 TB";
            break;

         case 3907029168:      // 2TB SAS/SATA
            sConverted = "2 TB";
            break;

         // -----------------------------------------------------------------------   
         // DEFAULT    <s>   
         //    
         default:
            isFound = false;
            break;
      }

      if (!isFound)
      {
         var MKT_BYTES_PER_MB = 1000000;
         var MKT_MB_PER_GB = 1000;
         var BYTES_PER_BLOCK = 512;

         var MB_TOTAL = (nBlocks * BYTES_PER_BLOCK) / MKT_BYTES_PER_MB;

         if (MB_TOTAL >= MKT_MB_PER_GB)
         {
            sConverted = MB_TOTAL / MKT_MB_PER_GB + " GB";
         }
         else
         {
            sConverted = MB_TOTAL + " MB";
         }
      }

      return sConverted;
   }

   function printJaveObject(obj)
   {
      var out = '';
      for (var p in obj)
      {
         out += p + ': ' + obj[p] + '\n';
      }
      alert(out);
   }

   function printJaveObject2(obj)
   {
      var out = '';
      for (var p in obj)
      {
         out += p + ': ' + obj[p] + '||';
      }
      alert(out);
   }

   function filterIcon(iconFileName, iconHeight, iconWidth, iconClass, iconID, imgExtraAttributes)
   {
      if (typeof (iconClass) == "undefined" || iconClass == '')
      {
         iconClass = "";
      }
      else if (iconClass != '')
      {
         iconClass = "class='" + iconClass + "'";
      }
      if (typeof (iconID) == "undefined" || iconID == '')
      {
         iconID = "";
      }
      else if (iconID != '')
      {
         iconID = " id='" + iconID + "'";
      }
      if (typeof (imgExtraAttributes) == "undefined" || imgExtraAttributes == '')
      {
         imgExtraAttributes = "";
      }
      else if (imgExtraAttributes != '')
      {
         imgExtraAttributes = " " + imgExtraAttributes;
      }
      var imgType = iconFileName.substr(iconFileName.length - 3, 3);

      if (g_isMoz || imgType != "png") // make sure we don't filter gif's, because filtered gif's will not be animated in IE6
      {
         var iconHtml = "<img align='absmiddle' " + iconClass + iconID + " style='border:none;height:" + iconHeight + ";width:" + iconWidth + ";' src='" + iconFileName + "'" + imgExtraAttributes + "/>";
      }
      else
      {
         var iconHtml = "<!--[if lt IE 7]><img src='images/spacer9.gif' align='absmiddle' " + iconClass + iconID + " style=border:none;height:" + iconHeight + ";width:" + iconWidth + ";filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + iconFileName + "',sizingMethod='scale');" + imgExtraAttributes + " /><![endif]--><!--[if gte IE 7]><img align='absmiddle' " + iconClass + iconID + " style='border:none;' src='" + iconFileName + "'" + imgExtraAttributes + " /><![endif]-->";
      }
      return iconHtml;
   }



   // Returns the header icon HTML for a device. Made global for dynamic updates to work.
   function getHeaderIconHTML(oSSD)
   {
      var sSelectedSrc = "images/sasssddrive60.png";
      if (oSSD.getInterface() == "Solid State SATA Drive")
      {
         sSelectedSrc = "images/satassddrive60.png";
      }

      //var sStateOverlaySrc = device.getAttribute("GUI_NAME_OVERLAY_ICON_LARGE"); // pause, queued...
      //var sOverlaySrc = device.getAttribute("GUI_NAME_STATUS_ICON_LARGE");
      //var sTLOverlaySrc = device.getAttribute("GUI_NAME_OVERLAY_TL_ICON_LARGE"); // boot...
      var sStateOverlaySrc, sTLOverlaySrc;
      var sOverlaySrc = "images/spacer12.gif";
      var nStatusValue = oSSD.getStatus();
      if (nStatusValue == 1)
      {
         sOverlaySrc = "images/critical36.png";
      }
      else if (nStatusValue == 2)
      {
         sOverlaySrc = "images/degraded36.png";
      }
      else if (nStatusValue == 3)
      {
         sOverlaySrc = "images/infostat36.png";
      }

      var sSpacer = "images/spacer12.gif"
      if (typeof (sStateOverlaySrc) == "undefined" || sStateOverlaySrc == "")
      {
         sStateOverlaySrc = sSpacer;
      }
      if (typeof (sOverlaySrc) == "undefined" || sOverlaySrc == "")
      {
         sOverlaySrc = sSpacer;
      }
      if (typeof (sTLOverlaySrc) == "undefined" || sTLOverlaySrc == "")
      {
         sTLOverlaySrc = sSpacer;
      }

      var iconHTML = filterIcon(sSelectedSrc, '60px', '60px', 'TaskImage', 'TaskIcon');
      // Add overlay
      if (sStateOverlaySrc != sSpacer)
      {
         iconHTML += filterIcon(sStateOverlaySrc, '36px', '36px', 'TaskOverlay');
         // Add status overlay to the left of the state overlay
         iconHTML += filterIcon(sOverlaySrc, '36px', '36px', 'TaskOverlayLeft');
      }
      else
      {
         iconHTML += filterIcon(sOverlaySrc, '36px', '36px', 'TaskOverlay');
         iconHTML += filterIcon(sStateOverlaySrc, '36px', '36px', 'TaskOverlayLeft');
      }
      iconHTML += filterIcon(sTLOverlaySrc, '36px', '36px', 'TaskOverlayTL');
      return iconHTML;
   }


   function HandleOnLoad()
   {
      // Check where this called from.
      if (typeof (parent.globalCallFromApp) != 'undefined' && parent.globalCallFromApp == true)
      {
         // If this page is called from ADU app, parent.globalCallFromApp is set to true in ADU.frm.
         g_isViewer = false;
      }
      else
      {
         // If this page is called from viewer, parent.globalCallFromApp is not set.
         g_isViewer = true;
      }

      // fake is to display image version in the viewer mode..
      var fake = false;
      if (g_isViewer || fake) // Viewer
      {
         g_sTreeExpandBtn = "+";
         g_sTreeContractBtn = "-";

         if (fake == true)
         {
            g_isViewer = false;
            g_sTreeExpandBtn = "images/themes/blue/button_tree_expand.gif";
            g_sTreeContractBtn = "images/themes/blue/button_tree_contract.gif";
         }
         else
         {
            g_sTreeToggleClass += "Viewer";
            g_sSSDInfoHeaderClass += "Viewer";
            CResizeCtrl.bannerAdjust = 40;
            CResizeCtrl.verticalMarginOffset = 5;
         }
         var req = new ajaxRequest();
         req.onreadystatechange = function()
         {
            if (req.readyState == 4)
            {
               if (req.status == 200 || window.location.href.indexOf("http") == -1)
               {
                  g_sJSONData = eval("(" + req.responseText + ")"); // retrieve result as a JavaScript object
                  g_oSmartSSDWearGaugeReport = new CSmartSSDWearGaugeReport("DIV_STATUS_ID", "DIV_INFO_ID", "DIV_VIEW_ID", "DIV_TREE_ID");
                  g_oSmartSSDWearGaugeReport.draw();
               }
               else
               {
                  alert("An error has occured making the request");
               }
            }
         }

         req.open("POST", "SmartSSDWearGaugeReport.json", true);
         req.send(null);
      }
      else // ADU 
      {
         parent.document.title = "HP Array Diagnostics and SmartSSD Wear Gauge Utility : View SSD Report";

         g_sTreeExpandBtn = "images/themes/blue/button_tree_expand.gif";
         g_sTreeContractBtn = "images/themes/blue/button_tree_contract.gif";

         var reportRequestor = new CRequestor();
         reportRequestor.setRequestType("ADUReportContent.js");
         reportRequestor.setEvalResult(false);

         g_sJSONData = eval("(" + reportRequestor.executeRequest() + ")"); // retrieve result as a JavaScript object
         g_oSmartSSDWearGaugeReport = new CSmartSSDWearGaugeReport("DIV_STATUS_ID", "DIV_INFO_ID", "DIV_VIEW_ID", "DIV_TREE_ID");
         g_oSmartSSDWearGaugeReport.draw();
         //RunReportEmbeddedJavaScript();
         parent.footerArea.saveReportButton.onclick = function() { document.location = "ADUSSDReport.zip" };
         parent.footerArea.ShowSaveButton();
         parent.footerArea.ShowHomeButton();
         parent.footerArea.ShowCancelButton(false);
      }
   }

   // Resize "class".
   function CResizeCtrl()
   {
   }

   // Static constants
   CResizeCtrl.sideMargin = 5;
   CResizeCtrl.verticalMarginOffset = 0;
   CResizeCtrl.minDocumentWidth = 800;
   CResizeCtrl.minDocumentHeight = 400;
   CResizeCtrl.minSplitterWidth = 550;
   CResizeCtrl.minSplitterRightWidth = 300;
   if (g_isMoz)
   {
      CResizeCtrl.borderAdjust = 3;
      CResizeCtrl.paddingAdjust3 = 3;
      CResizeCtrl.paddingAdjust5 = 5;
      CResizeCtrl.paddingAdjust10 = 10;
   }
   else
   {
      CResizeCtrl.borderAdjust = 0;
      CResizeCtrl.paddingAdjust3 = 0;
      CResizeCtrl.paddingAdjust5 = 0;
      CResizeCtrl.paddingAdjust10 = 0;
   }

   // Public static variables
   CResizeCtrl.bannerAdjust = 0; // different if g_isViewer when set is true
   CResizeCtrl.documentWidth = 0;
   CResizeCtrl.documentHeight = 0;
   CResizeCtrl.splitterWidth = 0;
   CResizeCtrl.splitterOffsetWidth = 0;
   CResizeCtrl.statusOffsetHeight = 0;
   CResizeCtrl.viewOffsetHeight = 0;
   CResizeCtrl.ssdMiddleLeftWidthUnitValuePrePxString = CResizeCtrl.minSplitterWidth;

   // This function is called by CSplitterBar to set the new width (and force a resize)
   // for the SmartSSD Wear Gauge page.
   CResizeCtrl.setSplitterUnitWidthValue = function(nNewValue)
   {
      CResizeCtrl.ssdMiddleLeftWidthUnitValuePrePxString = nNewValue;
      CResizeCtrl.handleResize();
   }

   // Retrieve window dimensions and make sure they are not too small
   CResizeCtrl.getWindowDimensions = function()
   {
      CResizeCtrl.documentWidth = document.body.clientWidth;
      CResizeCtrl.documentHeight = document.body.clientHeight;
      // if the window is smaller than our minimum sizes, do not allow the controls to shrink any further
      if (CResizeCtrl.documentWidth < CResizeCtrl.minDocumentWidth)
      {
         CResizeCtrl.documentWidth = CResizeCtrl.minDocumentWidth;
      }
      if (CResizeCtrl.documentHeight < CResizeCtrl.minDocumentHeight)
      {
         CResizeCtrl.documentHeight = CResizeCtrl.minDocumentHeight;
      }
   }

   CResizeCtrl.handleResize = function()
   {
      CResizeCtrl.getWindowDimensions();

      // Splitter - todo: add splitter.
      CResizeCtrl.splitterWidth = CResizeCtrl.ssdMiddleLeftWidthUnitValuePrePxString - CResizeCtrl.sideMargin;
      CResizeCtrl.splitterOffsetWidth = CResizeCtrl.splitterWidth + CResizeCtrl.sideMargin;

      // Report.
      var oReport = document.getElementById("SmartSSDWearGaugeReport");
      oReport.style.top = CResizeCtrl.bannerAdjust + "px";
      oReport.style.height = CResizeCtrl.documentHeight - CResizeCtrl.bannerAdjust + "px";
      oReport.style.width = CResizeCtrl.documentWidth + "px";

      // Status.
      var oStatus = document.getElementById("DIV_STATUS_ID");
      if (oStatus)
      {
         oStatus.style.width = CResizeCtrl.splitterWidth + "px";
         oStatus.style.left = CResizeCtrl.sideMargin + "px";
         oStatus.style.top = CResizeCtrl.verticalMarginOffset + "px";
         CResizeCtrl.statusOffsetHeight = oStatus.offsetHeight + CResizeCtrl.sideMargin;
      }

      // View.
      var oView = document.getElementById("DIV_VIEW_ID");
      if (oView)
      {
         oView.style.width = CResizeCtrl.splitterWidth + "px";
         oView.style.left = CResizeCtrl.sideMargin + "px";
         oView.style.top = CResizeCtrl.statusOffsetHeight +
                           CResizeCtrl.verticalMarginOffset + "px";
         CResizeCtrl.viewOffsetHeight = oView.offsetHeight;
      }

      // Tree.
      var oTree = document.getElementById("DIV_TREE_ID");
      if (oTree)
      {
         oTree.style.left = CResizeCtrl.sideMargin + "px";
         oTree.style.top = CResizeCtrl.statusOffsetHeight + CResizeCtrl.viewOffsetHeight + "px";
         var nTreeHeight = CResizeCtrl.documentHeight - CResizeCtrl.bannerAdjust - CResizeCtrl.statusOffsetHeight - CResizeCtrl.viewOffsetHeight - CResizeCtrl.borderAdjust - CResizeCtrl.verticalMarginOffset - (CResizeCtrl.paddingAdjust5 * 2);
         oTree.style.height = nTreeHeight + "px";
         oTree.style.width = CResizeCtrl.splitterWidth - (CResizeCtrl.borderAdjust * 2) - (CResizeCtrl.paddingAdjust5 * 2) + "px";
      }

      // Info.
      var oInfo = document.getElementById("DIV_INFO_ID");
      if (oInfo)
      {
         oInfo.style.height = CResizeCtrl.documentHeight - CResizeCtrl.bannerAdjust - (CResizeCtrl.verticalMarginOffset * 2) - (CResizeCtrl.borderAdjust * 2) - CResizeCtrl.paddingAdjust3 - CResizeCtrl.paddingAdjust10 + "px";
         oInfo.style.left = CResizeCtrl.splitterOffsetWidth + CResizeCtrl.sideMargin + "px";
         oInfo.style.top = CResizeCtrl.verticalMarginOffset + "px";
         oInfo.style.width = CResizeCtrl.documentWidth - CResizeCtrl.splitterOffsetWidth - (CResizeCtrl.sideMargin * 2) - (CResizeCtrl.borderAdjust * 2) - (CResizeCtrl.paddingAdjust10 * 2) + "px";
      }
   }

   // CSplitterBar
   // Summary:          Provides the functionality of a vertical bar that splits a window into 
   //                   a left pane and aright pane
   // Public Methods:   CSplitterBar.Destructor() - Removes DOM event handlers to free up closures
   // Constructor:      sContainerId - DOM Id of bar container
   //                   sBarId - DOM Id of bar element. The bar element must be a child of the container element
   //                   SetLeftSizeFunc - Function that receives the size of the left side panel 
   //                         after any resize operation
   //                   nElementOffset - Offset value between the window's client area and the container's client area
   //                   nMinLeftSize - Minimum size (in pixels) that the left pane may be
   //                   nMinrightSize- Minimum size (in pixels) that the right pane may be
   function CSplitterBar(sContainerId, sBarId, SetLeftSizeFunc, nElementOffset, nMinLeftSize, nMinRightSize)
   {
      var m_bMouseCaptured = false;   // When true, this control tracks the position of the mouse
      var m_splitterLeft = 0;

      // Called whenever the user clicks on the bar element
      function SplitterMouseDown(mevt)
      {
         var evt = mevt || window.event;
         m_bMouseCaptured = true;
         var sc = document.getElementById(sContainerId);
         sc.style.cursor = "col-resize";
         var sb = document.getElementById(sBarId);
         // save the current position of the splitter bar
         m_splitterLeft = parseInt(sb.style.left);
         sb.style.backgroundColor = "#808080";
         sb.style.left = (evt.clientX - Math.floor(parseInt(sb.style.width) / 2) - nElementOffset) + "px";
         return false;
      }
      // Called whenever the user moves the mouse while they have the button down
      function SplitterMouseMove(mevt)
      {
         if (m_bMouseCaptured)
         {
            var evt = mevt || window.event;
            var sb = document.getElementById(sBarId);
            var nPosition = evt.clientX - Math.floor(parseInt(sb.style.width) / 2) - nElementOffset;
            // If the user is trying to make the left pane too small, don't let them
            if (nMinLeftSize && nPosition > nMinLeftSize)
            {
               var clientWidth = document.body.clientWidth;
               // If the user is trying to make the right pane too small, don't let them
               if (nMinRightSize && clientWidth - nPosition < nMinRightSize)
               {
                  nPosition = m_splitterLeft > clientWidth - nMinRightSize ? m_splitterLeft : clientWidth - nMinRightSize;
               }
            }
            else
            {
               if (nMinLeftSize)
               {
                  nPosition = nMinLeftSize;
               }
            }
            sb.style.left = nPosition + "px";
            return false;
         }
         else
            return true;
      }
      // Called whenever the user stops dragging the splitter bar
      function SplitterMouseUp(mevt)
      {
         if (m_bMouseCaptured)
         {
            var evt = mevt || window.event;
            var sc = document.getElementById(sContainerId);
            sc.style.cursor = "";
            var sb = document.getElementById(sBarId);
            sb.style.backgroundColor = "";
            // Set the width of the left side by calling the supplied function
            SetLeftSizeFunc(parseInt(sb.style.left));
         }
         m_bMouseCaptured = false;
         return true;
      }
      // Called whenever the user leaves the splitter container
      function SplitterMouseLeave(mevt)
      {
         if (m_bMouseCaptured)
         {
            // Reset position to starting values
            var sc = document.getElementById(sContainerId);
            sc.style.cursor = "";
            var sb = document.getElementById(sBarId);
            sb.style.backgroundColor = "";
            sb.style.left = m_splitterLeft + "px";
         }
         m_bMouseCaptured = false;
         return false;
      }

      // Assign functions to elements (this creates some closures)
      var oContainer = document.getElementById(sContainerId);
      if (oContainer)
      {
         oContainer.onmousemove = SplitterMouseMove;
         oContainer.onmouseup = SplitterMouseUp;
         oContainer.onmouseleave = SplitterMouseLeave;
      }
      var oBar = document.getElementById(sBarId);
      if (oBar)
      {
         oBar.onmousedown = SplitterMouseDown;
      }
      if (!oContainer || !oBar)
      {
         var s = "CSplitterBar(Constructor): One of the required DOM elements (" + sContainerId + "," + sBarId + ") does not exist";
         alert(s);
      }

      // This is yet another closure to be used by the class destructor
      function InstanceDestructor()
      {
         //Remove events on the DOM to free up the closures
         var oContainer = document.getElementById(sContainerId);
         if (oContainer)
         {
            oContainer.onmousemove = null;
            oContainer.onmouseup = null;
            oContainer.onmouseleave = null;
         }
         var oBar = document.getElementById(sBarId);
         if (oBar)
         {
            oBar.onmousedown = null;
         }
      }
      // Register this class's instance destructor with the class destructor
      CSplitterBar.RegisterDestructor(InstanceDestructor);
   }

   // Static members
   CSplitterBar.destructors = 0;

   // Save all the instance destructors
   CSplitterBar.RegisterDestructor = function(fInstanceDestructor)
   {
      if (!CSplitterBar.destructors)
         CSplitterBar.destructors = new Array();
      CSplitterBar.destructors[CSplitterBar.destructors.length] = fInstanceDestructor;
   }
   // Call all instance destructors
   CSplitterBar.Destructor = function()
   {
      for (var x in CSplitterBar.destructors)
      {
         // Call the instance destructor
         CSplitterBar.destructors[x]();
         CSplitterBar.destructors[x] = null;
         delete CSplitterBar.destructors[x];
      }
      CSplitterBar.destructors = 0;
   }
</script>
</head>
<body onload="HandleOnLoad();" onresize="CResizeCtrl.handleResize();">
<div id="banner"></div>
<div id="SmartSSDWearGaugeReport"></div>
</body>
</html>